package gus05.manager.gus.kassia.layer1;

import java.util.Date;

import gus05.framework.core.Outside;
import gus05.manager.gus.kassia.layer1.organs.AppLauncher;
import gus05.manager.gus.kassia.layer1.organs.ErrorHandler;
import gus05.manager.gus.kassia.layer1.organs.KeyFinder;
import gus05.manager.gus.kassia.layer1.organs.ResourceProvider;
import gus05.manager.gus.kassia.layer1.organs.ServiceWrapper;



public abstract class KassiaApp {

    protected KassiaApp(String[] args)
    {
        Date date = new Date();
        
        KeyFinder kf = buildKeyFinder();
        ResourceProvider rp = buildResourceProvider();
        ServiceWrapper sw = buildServiceWrapper();
        ErrorHandler eh = buildErrorHandler();
        AppLauncher al = buildAppLauncher();
        
        Outside.setManager(new KassiaManager(kf,rp,sw,eh));
        al.launchApp(this,date,args);
    }
    
    
    protected abstract KeyFinder buildKeyFinder();
    protected abstract ServiceWrapper buildServiceWrapper();
    protected abstract ResourceProvider buildResourceProvider();
    protected abstract ErrorHandler buildErrorHandler();
    protected abstract AppLauncher buildAppLauncher();
}
