
package gus05.manager.gus.kassia.layer1;

import gus05.framework.core.Entity;
import gus05.framework.core.Manager;
import gus05.framework.core.Service;
import gus05.manager.gus.kassia.layer1.organs.ErrorHandler;
import gus05.manager.gus.kassia.layer1.organs.KeyFinder;
import gus05.manager.gus.kassia.layer1.organs.ResourceProvider;
import gus05.manager.gus.kassia.layer1.organs.ServiceWrapper;


public final class KassiaManager implements Manager {

	
	private KeyFinder kf;
    private ResourceProvider rp;
    private ServiceWrapper sw;
    private ErrorHandler eh;
    
    KassiaManager(KeyFinder kf, ResourceProvider rp, ServiceWrapper sw, ErrorHandler eh)
    {
    	this.kf = kf;
    	this.rp = rp;
    	this.sw = sw;
    	this.eh = eh;
    }
    
    
    
    
    public Service callService(Entity entity, String id) throws Exception
    {
        Source src = new Source(entity,id);
        String key = kf.findKey(src);
        Object obj = rp.provideResource(src,key);
        return sw.wrapService(src,obj);
    }
    
    public Object callResource(Entity entity, String id) throws Exception
    {
        Source src = new Source(entity,id);
        String key = kf.findKey(src);
        return rp.provideResource(src,key);
    }

    public void sendError(Entity entity, String id, Exception e)
    {eh.handleError(entity,id,e);}
}
