package gus05.manager.gus.kassia.layer2;

import gus05.framework.core.Entity;
import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer1.Source;
import gus05.manager.gus.kassia.layer2.tools.*;
import gus05.manager.gus.kassia.layer3.KS7;

import java.util.Date;
import java.util.Iterator;
import java.util.Properties;


public class KassiaSystem {

	
	public static final String MANAGERBUILD						= "20110617";
    public static final String MANAGERID						= "Kassia_"+MANAGERBUILD;
    
    public static final String INTERNAL_APPARGS                 = "internal.args";
    public static final String INTERNAL_APPOBJECT               = "internal.object";
    public static final String INTERNAL_APPSTARTDATE            = "internal.startdate";
    public static final String INTERNAL_MANAGERID               = "internal.managerid";
    public static final String INTERNAL_MAP_INTERNAL            = "internal.internalmap";
    public static final String INTERNAL_MAP_POOL                = "internal.poolmap";
    public static final String INTERNAL_MAP_PROPS		        = "internal.propmap";
    public static final String INTERNAL_MAP_CLASSENTITY         = "internal.entitymap";
    public static final String INTERNAL_MAP_MULTIPLICITY        = "internal.multiplicitymap";
    public static final String INTERNAL_MAP_MAPPING             = "internal.mapping";
    public static final String INTERNAL_MAP_PARAMS              = "internal.params";
    public static final String INTERNAL_LIST_ERROR              = "internal.errorlist";
    public static final String INTERNAL_INSIDE     				= "internal.inside";
    
    public static final String POOL_RESOURCEPROVIDER    		= "app.resourceprovider";
    public static final String POOL_RESOURCECHANGER	    		= "app.resourcechanger";
    public static final String POOL_MAPPINGRECORDER     		= "app.mappingrecorder";
    public static final String POOL_MAPPINGHANDLER	     		= "app.mappinghandler";
    public static final String POOL_SERVICEWRAPPER  			= "app.servicewrapper";
    
    public static final String ENTITYNAMESTART					= "gus05.entity.";
    public static final String MULTIPLICITYVALUE_MULTIPLE		= "MULTIPLE";
    public static final String MULTIPLICITYVALUE_UNIQUE			= "UNIQUE";
    
    public static final String PARAM_INSIDE						= "inside";
	public static final String PARAM_PROP						= "prop";
	public static final String PARAM_LOAD						= "load";
	public static final String PARAM_START						= "start";
	
	public static final String PARAMDEFAULT_INSIDE				= "/gus05/resource/gus/kassia/";
	public static final String PARAMDEFAULT_PROP				= "prop";
	public static final String PARAMDEFAULT_LOAD				= "load";
	public static final String PARAMDEFAULT_START				= "start";
    
	public static final String PROPKEY_APPNAME					= "app.name";
	public static final String PROPKEY_APPTITLE					= "app.title";
	public static final String PROPKEY_APPVERSION				= "app.version";
    public static final String PROPKEY_APPBUILD					= "app.build";
    
    public static final String APPDEFAULT_NAME					= "Kassia_core1";
    public static final String APPDEFAULT_TITLE					= "Kassia application";
    public static final String APPDEFAULT_VERSION				= "N";
    public static final String APPDEFAULT_BUILD					= "N";
    
    public static final String INIT_THREADID					= "KASSIA_INIT_THREAD";
    
    
    
    
    
    
    protected static Date appStartDate;
    protected static Object appObject;
    protected static String[] appArgs;
    protected static String appArgsLine;
    
    protected static SupportList errors;
    protected static SupportMap mapping;
    protected static SupportMap pool;
    
    protected static LockableMap props;
    protected static LockableMap params;
    protected static LockableMap entities;
    protected static LockableMap multiplicities;
    protected static LockableMap internal;
    
    protected static Inside inside;
    protected static Thread initThread;
    
    
    
    
    
    protected static void initSystem(Object object, Date startDate, String[] args)
    {
        try
        {
            errors = new SupportList("errors");
            mapping = new SupportMap("mapping");
            pool = new SupportMap("pool");
            
            props = new LockableMap("props");
            params = new LockableMap("params");
            entities = new LockableMap("entities");
            multiplicities = new LockableMap("multiplicities");
            internal = new LockableMap("internal");
            
            appStartDate = startDate;
            appObject = object;
            
            formatArgs(args);
            initParams();
            initInside();
            initProps();
            initEntities();
            initInternal();
            
            props.lock();
            params.lock();
            entities.lock();
            multiplicities.lock();
            internal.lock();
        }
        catch(Exception e)
        {fatalError_initSystem(e);}
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    private static void formatArgs(String[] args)
    {
        if(args.length==0)
        {
        	appArgsLine = "";
        	appArgs = new String[0];
        	return;
        }
        StringBuilder b = new StringBuilder(args[0]);
        for(int i=1;i<args.length;i++) b.append(" "+args[i]);
        appArgsLine = b.toString();
        
        appArgs = appArgsLine.replace(";;","\\u152").split(";",-1);   // character \\u152 = 
        for(int i=0;i<appArgs.length;i++) appArgs[i] = appArgs[i].replace("\\u152",";");
    }
    
    
    
    private static void initParams() throws Exception
    {
    	for(int i=0;i<appArgs.length;i++)
    	if(appArgs[i].contains("="))
    	{
    		String[] n = appArgs[i].split("=",2);
    		String key = n[0];
    		String value = n[1];

    		if(params.containsKey(key))
    			throw new Exception("Param ["+key+"] is found many times inside args");
    		params.put(key,value);
    	}
    }
    
    
    private static void initInside()
    {
    	String id = param(PARAM_INSIDE,PARAMDEFAULT_INSIDE);
    	inside = new Inside(id);
    }
    
    
    private static void initProps() throws Exception
    {
    	String id = param(PARAM_PROP,PARAMDEFAULT_PROP);
        Properties p = inside.prop(id);
        if(p!=null)props.putAll(p);
        
        initProp(PROPKEY_APPNAME,APPDEFAULT_NAME);
		initProp(PROPKEY_APPTITLE,APPDEFAULT_TITLE);
		initProp(PROPKEY_APPVERSION,APPDEFAULT_VERSION);
		initProp(PROPKEY_APPBUILD,APPDEFAULT_BUILD);
    }
    
    private static void initProp(String key, String value)
    {if(!props.containsKey(key)) props.put(key,value);}
    
    
    
    private static void initEntities() throws Exception
    {
    	String id = param(PARAM_LOAD,PARAMDEFAULT_LOAD);
        Properties p = inside.prop(id);
        if(p==null) return;
        
    	Iterator it = p.keySet().iterator();
    	while(it.hasNext())
    	{
    		String key = (String)it.next();
    		String value = p.getProperty(key);
    		if(!key.startsWith("#")) initEntity(key,value);
    	}
    }
    
    
    private static void initEntity(String key, String value) throws Exception
    {
    	if(!value.contains("."))
    		value = key+"."+value;
    	if(!value.startsWith(ENTITYNAMESTART))
			value = ENTITYNAMESTART+value;
    	
    	if(value.endsWith("+"))
    		multiplicities.put(key,MULTIPLICITYVALUE_UNIQUE);
    	else if(value.endsWith("*"))
    		multiplicities.put(key,MULTIPLICITYVALUE_MULTIPLE);
    	else throw new Exception("Invalid internal entity definition: ["+value+"] for entity ["+key+"]");
    	
		value = value.substring(0,value.length()-1);
		Class c = Class.forName(value);
		entities.put(key,c);
    }
    
    
    
    
    
    
    
    
    
    private static void initInternal()
    {
    	internal.put(INTERNAL_APPARGS,appArgs);
        internal.put(INTERNAL_APPOBJECT,appObject);
        internal.put(INTERNAL_APPSTARTDATE,appStartDate);
        internal.put(INTERNAL_MANAGERID,MANAGERID);
        internal.put(INTERNAL_MAP_INTERNAL,internal);
        internal.put(INTERNAL_MAP_POOL,pool);
        internal.put(INTERNAL_MAP_PROPS,props);
        internal.put(INTERNAL_MAP_CLASSENTITY,entities);
        internal.put(INTERNAL_MAP_MULTIPLICITY,multiplicities);
        internal.put(INTERNAL_MAP_MAPPING,mapping);
        internal.put(INTERNAL_MAP_PARAMS,params);
        internal.put(INTERNAL_LIST_ERROR,errors);
        internal.put(INTERNAL_INSIDE,inside);
    }
    
    
    
    
    
    
    
    
    
   
    
    
    
    
    
    
    //*******************************************************
    
    protected static Object find(String key)
    {
        if(pool.containsKey(key)) return pool.get(key);
        if(internal.containsKey(key)) return internal.get(key);
        return null;
    }
    
    
    private static String param(String key, String defaultValue)
    {
    	if(params.containsKey(key)) return (String) params.get(key);
    	if(props.containsKey("param."+key)) return prop("param."+key);
    	return defaultValue;
    }
    
    
    private static String prop(String key)
    {return (String) props.get(key);}
    
    
    
    
    
    
    
    
    
    
    protected static Retrieve findResourceProvider()
    {return (Retrieve) find(POOL_RESOURCEPROVIDER);}
    
    protected static Transform findResourceChanger()
    {return (Transform) find(POOL_RESOURCECHANGER);}
    
    protected static Register findMappingRecorder()
    {return (Register) find(POOL_MAPPINGRECORDER);}
    
    protected static Transform findMappingHandler()
    {return (Transform) find(POOL_MAPPINGHANDLER);}
    
    protected static Transform findServiceWrapper()
    {return (Transform) find(POOL_SERVICEWRAPPER);}
    
    
    
    
    
    	
    
     
    
    
    
    
    
    
    //*******************************************************
    
    
    protected static void startApplication()
    {
    	try
        {
    		String startKey = param(PARAM_START,PARAMDEFAULT_START);
        	if(startKey.equals(PARAMDEFAULT_START)) KS7.start();
        	else startApplication_special(startKey);
        }
        catch(Exception e)
        {fatalError_startApplication(e);}
    }
    
    
    
    private static void startApplication_special(String startKey)
    {
    	try
        {
    		if(!entities.containsKey(startKey))
                throw new Exception("Unknown internal entity for special start: ["+startKey+"]");
            Class c = (Class) entities.get(startKey);
            c.newInstance();
        }
    	catch(Exception e)
        {fatalError_startApplication_special(e);}
    }
    
    

    
    
    
    
    
    //*******************************************************

    private static Exception e1;
    
    protected synchronized static void err(Object source, String id, Exception e)
    {
    	if(e1!=null)
    	{
    		String message = "An exception occured while resolving error: "+e1;
    		fatalError_err(new Exception(message,e));
    	}
    	e1 = e;
    	errors.add(new Object[]{source,id,e,new Date()});
    	e1 = null;
    }
    
    
    
    
    
    
    
    //*******************************************************
    
    protected synchronized static void fatalError_initSystem(Throwable e)
    {new FatalErrorHolder("initSystem",1,e);}
    
    protected synchronized static void fatalError_startApplication(Throwable e)
    {new FatalErrorHolder("startApplication",2,e);}
    
    protected synchronized static void fatalError_startApplication_special(Throwable e)
    {new FatalErrorHolder("startApplication_special",3,e);}
    
    protected synchronized static void fatalError_uncaughtException(Throwable e)
    {new FatalErrorHolder("uncaughtException",4,e);}
    
    protected synchronized static void fatalError_err(Throwable e)
    {new FatalErrorHolder("err",5,e);}
    
    
    
    
    
    //*******************************************************

    public static String name(Object s)
    {
        if(s==null) return "null";
        if(s instanceof Source) return s.toString();
        if(s instanceof Entity) return ((Entity)s).getName();
        if(s instanceof Class) return ((Class)s).getSimpleName();
        return s.getClass().getSimpleName();
    }
    
    
    
    public static String state()
    {
    	return "[er,ma,pr,po,pa,en,in]=["+
    			errors.size()+","+
    			mapping.size()+","+
    			props.size()+","+
    			pool.size()+","+
    			params.size()+","+
    			entities.size()+","+
    			internal.size()+"]";
    }
    
    
    public static String id()
    {
    	return prop(PROPKEY_APPNAME)+"|"+
    			prop(PROPKEY_APPVERSION)+"|"+
    			prop(PROPKEY_APPBUILD);
    }
}
