package gus05.manager.gus.kassia.layer2.organs_impl;

import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer1.Source;
import gus05.manager.gus.kassia.layer1.organs.ResourceProvider;
import gus05.manager.gus.kassia.layer2.KassiaSystem;


public class Impl_ResourceProvider extends KassiaSystem implements ResourceProvider {

    
    public Object provideResource(Source src, String key) throws Exception
    {
        if(key.equals("null")) return null;
        if(key.equals("pool")) return pool;
        if(key.equals("internal")) return internal;
        
        Object resource = searchForResource(src,key);
        return changeResource(src,key,resource);
    }
    
    
    private Object searchForResource(Source src, String key) throws Exception
    {
    	key = removeTail(key);
    	Object obj = find(key);
        if(obj!=null) return obj;
        
        Retrieve provider = findResourceProvider();
        if(provider==null) throw new Exception("No resource provider available inside pool");
        
        Register provider_reg = (Register) provider;
        provider_reg.register("entity",src.getEntity());
        provider_reg.register("id",src.getId());
        
        return provider.retrieve(key);
    }
    
    
    private Object changeResource(Source src, String key, Object resource)
    {
    	try
        {
    		Transform t = (Transform) findResourceChanger();
            if(t!=null) return t.transform(toDataTab(src,key,resource));
        }
        catch(Exception e)
        {err(this,"changeResource(Source,String,Object)",e);}
    	return resource;
    }
    
    
    private Object[] toDataTab(Source src, String key, Object obj)
    {return new Object[]{src.getEntity(),src.getId(),key,obj};}
    
    
    
    private String removeTail(String key)
    {
    	if(!key.contains("-")) return key;
    	String[] n = key.split("-",2);
    	if(!isInteger(n[1])) return key;
    	return n[0];	
    }
    
    private boolean isInteger(String s)
    {
    	try{Integer.parseInt(s);return true;}
    	catch(Exception e){return false;}
    }
}
