package gus05.manager.gus.kassia.layer2.services;

import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.JComponent;

import gus05.framework.core.Service;
import gus05.framework.features.*;
import gus05.manager.gus.kassia.layer1.Source;
import gus05.manager.gus.kassia.layer2.KassiaSystem;


public class DefaultService implements Service {

    
    private Object target;
    private Source source;

    
    private Execute execute;
    private Filter filter;
    private Function function;
    private Give give;
    private Graphic graphic;
    private Provide provide;
    private Register register;
    private Retrieve retrieve;
    private Support support;
    private Transform transform;
    private Runnable runnable;
    
    
    
    private void notAvailable(String feature) throws Exception
    {throw new Exception(feature+" not available for "+source+" (="+KassiaSystem.name(target)+")");}
    
    
    /*
     * AMELIORATION POSSIBLE DU SYSTEME :
     * permettre la craction de l'objet target au moment du premier appel de mthode
     * en passant non pas l'objet target lui mme mais un "provide target" de type Provide
     */
    public DefaultService(Source source, Object target)
    {
        this.source = source;
        this.target = target;
        
        if(target instanceof Execute)		execute = (Execute)target;
        if(target instanceof Filter)		filter = (Filter)target;
        if(target instanceof Function)		function = (Function)target;
        if(target instanceof Give)			give = (Give)target;
        if(target instanceof Graphic)		graphic = (Graphic)target;
        if(target instanceof Provide)		provide = (Provide)target;
        if(target instanceof Register)		register = (Register)target;
        if(target instanceof Retrieve)		retrieve = (Retrieve)target;
        if(target instanceof Support)		support = (Support)target;
        if(target instanceof Transform)		transform = (Transform)target;
        if(target instanceof Runnable)		runnable = (Runnable)target;
    }
    
    
    
    
    public void execute() throws Exception
    {
        if(execute==null) notAvailable("execute");
        execute.execute();
    }
    

    public boolean filter(Object obj) throws Exception
    {
        if(filter==null) notAvailable("filter");
        return filter.filter(obj);
    }

    
    public double function(double value) throws Exception
    {
        if(function==null) notAvailable("function");
        return function.function(value);
    }
    

    public void give(Object obj) throws Exception
    {
        if(give==null) notAvailable("give");
        give.give(obj);
    }

    
    public Object provide() throws Exception
    {
        if(provide==null) notAvailable("provide");
        return provide.provide();
    }

    
    public void register(String key, Object obj) throws Exception
    {
        if(register==null) notAvailable("register");
        register.register(key,obj);
    }

    
    public Object retrieve(String key) throws Exception
    {
        if(retrieve==null) notAvailable("retrieve");
        return retrieve.retrieve(key);
    }
    
    
    public Object transform(Object obj) throws Exception
    {
        if(transform==null) notAvailable("transform");
        return transform.transform(obj);
    }
    
    
    public JComponent gui()
    {
        if(graphic==null) return null;
        return graphic.gui();
    }
    
    
    public void addActionListener(ActionListener listener)
    {
        if(support==null) return;
        support.addActionListener(listener);
    }

    
    public void removeActionListener(ActionListener listener)
    {
        if(support==null) return;
        support.removeActionListener(listener);
    }

    
    public List listeners()
    {
        if(support==null) return null;
        return support.listeners();
    }

    
    public void run()
    {
        if(runnable==null) return;
        runnable.run();
    }
}
