package gus05.manager.gus.kassia.layer2.tools;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

public class LockableMap implements Map {

    private Map map;
    private String name;
    
    private boolean locked = false;
    public void lock() {locked = true;}
    
    

    public LockableMap(String name)
    {
        this.name = name;
        this.map = new HashMap();
    }
    
    
    
    public void clear()                             {if(!locked) map.clear();}
    public void putAll(Map m)                       {if(!locked) map.putAll(m);}
    public Object put(Object key, Object value)     {return locked?null:map.put(key,value);}
    public Object remove(Object key)                {return locked?null:map.remove(key);}
    
    public boolean containsKey(Object key) {return map.containsKey(key);}
    public boolean containsValue(Object value) {return map.containsValue(value);}
    public boolean isEmpty() {return map.isEmpty();}
    public Collection values() {return map.values();}
    public Set entrySet() {return map.entrySet();}
    public Set keySet() {return map.keySet();}
    public Object get(Object key) {return map.get(key);}
    public int size() {return map.size();}
    
    public String toString() {return "lockable map "+name+" (size="+size()+")";}
}
