package gus05.manager.gus.kassia.layer3;

import java.applet.Applet;
import java.applet.AudioClip;
import java.io.File;
import java.io.InputStream;
import java.net.URL;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.filechooser.FileSystemView;

import gus05.framework.core.Entity;
import gus05.framework.features.Execute;
import gus05.framework.features.Filter;
import gus05.framework.features.Give;
import gus05.framework.features.Provide;
import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Support;
import gus05.framework.features.Transform;
import gus05.framework.tools.DefaultSupport;
import gus05.manager.gus.kassia.layer2.KassiaSystem;
import gus05.manager.gus.kassia.layer2.tools.SupportList;
import gus05.manager.gus.kassia.layer2.tools.SupportMap;
import gus05.manager.gus.kassia.layer2.tools.SupportSet;


public class KS1 extends KassiaSystem {

	
	/*
     * ARGUMENTS
     */
    public static boolean hasArg(String name)
    {
        name = name.toLowerCase();
        for(int i=0;i<appArgs.length;i++)
            if(appArgs[i].toLowerCase().equals(name)) return true;
        return false;
    }
    
    public static boolean hasArgs()
    {return appArgs.length>0;}
    
    public static boolean hasArgOrTrueParam(String name)
    {return hasArg(name) || booleanParam(name,false);}
    
    
    
    
    /*
     * PARAMS
     */
    public static boolean hasParam(String key)
    {return params.containsKey(key);}
    
    public static String getParam(String key)
    {return (String) params.get(key);}
    
    public static boolean checkParam(String key,String value)
    {return hasParam(key) && getParam(key).equals(value);}
    
    public static boolean booleanParam(String key, boolean defaultValue)
    {return hasParam(key)? getParam(key).equalsIgnoreCase("true"):defaultValue;}
    
    
    
    
    /*
     * POOL
     */
    public static boolean hasPool(String key)
    {return pool.containsKey(key);}
    
    public static void removePool(String key)
    {if(hasPool(key)) pool.remove(key);}
    
    public static void putPool(String key, Object value)
    {pool.put(key,value);}
    
    public static Object getPool(String key)
    {return hasPool(key)?pool.get(key):null;}
    
    public static void checkPool(String key) throws Exception
    {if(!hasPool(key)) throw new Exception("Object ["+key+"] not available inside pool");}
    
    
    
    public static void putPoolMap(String key)
    {putPool(key,supMap(key));}
    
    public static void putPoolSet(String key)
    {putPool(key,supSet(key));}
    
    public static void putPoolList(String key)
    {putPool(key,supList(key));}
    
    
    
    public static Map poolmap(String key)
    {return (Map) getPool(key);}
    
    public static Set poolset(String key)
    {return (Set) getPool(key);}
    
    public static List poollist(String key)
    {return (List) getPool(key);}
    
    public static Execute poolexe(String key)
    {return (Execute) getPool(key);}
    
    public static Register poolreg(String key)
    {return (Register) getPool(key);}
    
    public static Retrieve poolret(String key)
    {return (Retrieve) getPool(key);}
    
    public static DefaultSupport poolsup(String key)
    {return (DefaultSupport) getPool(key);}
    
    public static Transform pooltran(String key)
    {return (Transform) getPool(key);}
    
    public static Give poolgive(String key)
    {return (Give) getPool(key);}
    
    public static Provide poolpro(String key)
    {return (Provide) getPool(key);}
    
    public static Filter poolfilter(String key)
    {return (Filter) getPool(key);}
    
    
    
    /*
     * ERRORS
     */
    
    public static boolean hasErrors()
    {return !errors.isEmpty();}
    
    public static int errorNumber()
    {return errors.size();}
    
    public static Object[] getError(int index)
    {return (Object[]) errors.get(index);}
    
    public static Object[] getLastError()
    {return (Object[]) errors.get(errors.size()-1);}
    
    
    
    /*
     * INSIDE
     */
    public static URL insideURL(String key) throws Exception
    {return (URL) inside.retrieve("url."+key);}
    
    public static InputStream insideStream(String key) throws Exception
    {return (InputStream) inside.retrieve("stream."+key);}
    
    public static Properties insideProp(String key) throws Exception
    {return (Properties) inside.retrieve("prop."+key);}
    
    public static String insideText(String key) throws Exception
    {return (String) inside.retrieve("txt."+key);}
    
    public static Set insideListing(String key) throws Exception
    {return (Set) inside.retrieve("listing."+key);}
    
    
    
    /*
     * ENTITY
     */
    public static Entity createInternalEntity(String name) throws Exception
    {
        if(!entities.containsKey(name))
            throw new Exception("Unknown internal entity: ["+name+"]");
        Class c = (Class) entities.get(name);
        return newEntity(c,name);
    }
    
	public static final Entity ANONYMOUS_ENTITY = new Entity() {
		public String getCreationDate() {return "2010.07.22";}
		public String getName() {return "anonymousentity";}
	};
    
    
    
    
	/*
	 * APP RESOURCES LOADING
	 */
    public static int number_newEntities = 0;
    public static int number_newIcons = 0;
	public static int number_newAudios = 0;
	
	public static long time_newIcons = 0;
	public static long time_newAudios = 0;
	
	
	
    public static Entity newEntity(Class c, String name) throws Exception
    {
    	Entity entity = (Entity)c.newInstance();
    	
        String name0 = entity.getName();
        if(!name0.equals(name))
            throw new Exception("Entity name conflict o:["+name+"] i:["+name0+"]");
        
        number_newEntities++;
        return entity;
    }
    
	public static ImageIcon newIcon_URL(URL url)
	{
		long t1 = System.currentTimeMillis();
		ImageIcon icon = new ImageIcon(url);
		long t2 = System.currentTimeMillis();
		
		number_newIcons++;
		time_newIcons += (t2-t1);
		return icon;
	}
	
	public static Icon newIcon_File(File file)
	{
		long t1 = System.currentTimeMillis();
		Icon icon = FileSystemView.getFileSystemView().getSystemIcon(file);
		long t2 = System.currentTimeMillis();
		
		number_newIcons++;
		time_newIcons += (t2-t1);
		return icon;
	}
	
	public static AudioClip loadAudioClip(URL url)
	{
		long t1 = System.currentTimeMillis();
		AudioClip clip = Applet.newAudioClip(url);
		long t2 = System.currentTimeMillis();
		
		number_newAudios++;
		time_newAudios += (t2-t1);
		return clip;
	}
	
	
	
	
	
	
	/*
	 * SOURCE
	 */
	public static String src(Entity entity, String id)
	{return entity.getName()+"@"+id;}
	
	public static String src(String entityName, String id)
	{return entityName+"@"+id;}
	
	
	
    /*
     * SUPPORT
     */
    public static Support sup()
    {return new DefaultSupport();}

    public static Map supMap(String name)
    {return new SupportMap(name);}

    public static Set supSet(String name)
    {return new SupportSet(name);}
    
    public static List supList(String name)
    {return new SupportList(name);}
}
