package gus05.manager.gus.kassia.layer3;

import java.awt.Graphics2D;
import java.awt.GraphicsConfiguration;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.Image;
import java.awt.Transparency;
import java.awt.image.BufferedImage;
import java.io.Closeable;
import java.io.File;
import java.io.FileFilter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.nio.channels.FileChannel;
import java.text.NumberFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.Scrollable;

import gus05.framework.features.Filter;
import gus05.framework.features.Graphic;
import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer3.tools.Tool_storeArray;


public class KS2 extends KS1 {


    /*
     * JVM SYSTEM
     */
    public static final String SYS_JAVAVERSION = System.getProperty("java.version");
    public static final String SYS_JAVAHOME = System.getProperty("java.home");
    public static final String SYS_USERDIR = System.getProperty("user.dir");
    public static final String SYS_USERLANGUAGE = System.getProperty("user.language");
    
    public static final File DIR_SYS_USERDIR = new File(SYS_USERDIR);
    public static final File DIR_SYS_JAVAHOME = new File(SYS_JAVAHOME);
    
    public static final void EXIT_0() {System.exit(0);}
    
    
    
    
    /*
     * STRING FORMAT
     */
    public static final SimpleDateFormat yyyyMMdd_HHmmss_SS = new SimpleDateFormat("yyyyMMdd_HHmmss_SS");
    public static final SimpleDateFormat yyyyMMdd_HHmmss = new SimpleDateFormat("yyyyMMdd_HHmmss");
    public static final SimpleDateFormat yyyyMMdd = new SimpleDateFormat("yyyyMMdd");
    public static final SimpleDateFormat yyyyMM = new SimpleDateFormat("yyyyMM");
    public static final SimpleDateFormat yyyy = new SimpleDateFormat("yyyy");
    public static final SimpleDateFormat MM = new SimpleDateFormat("MM");
    public static final SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy.MM.dd HH:mm:ss");
    
    public static String yyyyMMdd_HHmmss_SS(Date d)	{return yyyyMMdd_HHmmss_SS.format(d);}
    public static String yyyyMMdd_HHmmss(Date d)	{return yyyyMMdd_HHmmss.format(d);}
    public static String yyyyMMdd(Date d)			{return yyyyMMdd.format(d);}
    public static String yyyyMM(Date d)				{return yyyyMM.format(d);}
    public static String yyyy(Date d)				{return yyyy.format(d);}
    public static String MM(Date d)					{return MM.format(d);}
    public static String sdf1(Date d)				{return sdf1.format(d);}
    
    public static NumberFormat numberFormat = NumberFormat.getInstance();
    
    public static String ns(long value) 			{return numberFormat.format(value)+" ns";}
    public static String ms(long value) 			{return numberFormat.format(value)+" ms";}
    
    public static String formatN(String s, String c, int l)
    {while(s.length()<l) s = c+s;return s;}
    
    public static String formatN(int n, int l)
    {return formatN(""+n,"0",l);}
    
    public static String formatN2(int n)
    {return formatN(n,2);}
    
    
    
    
    
    /*
     * TIME
     */
    public static String now_SS()					{return yyyyMMdd_HHmmss_SS(new Date());}
    public static String now()						{return yyyyMMdd_HHmmss(new Date());}
    public static String today()					{return yyyyMMdd(new Date());}
    public static String thisYear()					{return yyyy(new Date());}
    public static String thisMonth()				{return MM(new Date());}
    
    public static String startDate()				{return yyyyMMdd_HHmmss(appStartDate);}
    
    public static long timeFrom(Date d)				{return millis()-d.getTime();}
    public static long timeFromStart()				{return timeFrom(appStartDate);}
    
    public static String timeFromStart_ms()			{return ms(timeFrom(appStartDate));}
    public static long millis()						{return System.currentTimeMillis();}
    
    
    
    
    /*
     * THROWABLES
     */
    public static String toString(Throwable e)
    {
    	if(e.toString().startsWith("java.lang.Exception"))
    		return e.getMessage()+" ("+location(e)+")";
    	return e.toString()+" ("+location(e)+")";
    }
    
    public static String location(Throwable e)
    {
    	StackTraceElement[] ste_ = e.getStackTrace();
    	if(ste_.length==0) return null;
    	int n=0;
    	StackTraceElement ste = ste_[0];
    	while(ste.getFileName()==null && ste_.length>n+1) ste = e.getStackTrace()[++n];
    	return location(ste);
    }
    
    public static String location(StackTraceElement ste)
    {
    	return ste.getClassName()+"@"+ste.getMethodName()+" ("+ste.getFileName()+":"+ste.getLineNumber()+")";
    }
    
    public static String firstCauseToString(Throwable e)
    {
    	while(e.getCause()!=null) e = e.getCause();
    	return toString(e);
    }
    
    public static void printMessage(Throwable e, PrintStream p)
    {
    	p.println("> MESSAGE:"+toString(e));
    }
    
    public static void printCauses(Throwable e, PrintStream p)
    {
    	p.println("> CAUSES:");
    	p.println("caused by: "+toString(e));
    	while(e.getCause()!=null)
    	{
    		e = e.getCause();
    		p.println("caused by: "+toString(e));
    	}
    }
    
    public static void printStackTrace(Throwable e, PrintStream p)
    {
    	p.println("> STACK TRACE:");
        e.printStackTrace(p);
    }
    
    
    
    
    
    
    /*
     * FILES
     */
    public static String getResourceName(File file)
    {return getResourceName(file.getName());}
    
    public static String getResourceExtension(File file)
    {return getResourceExtension(file.getName());}
    
    public static String getResourceName(String name)
    {
        if(!name.contains(".")) return name;
        String[] n = name.split("\\.");
        int l = n[n.length-1].length();
        return name.substring(0,name.length()-1-l);
    }
    
    public static String getResourceExtension(String name)
    {
        if(!name.contains(".")) return "";
        String[] n = name.split("\\.");
        return n[n.length-1];
    }
    
    public static String display(File f)
    {
    	if(f==null) return "null";
    	if(!f.exists()) return "["+f+"] (does not exist)";
    	if(f.isFile()) return "["+f+"] (file)";
    	return "["+f+"] (dir)";
    }
    
    public static void copy(File in, File out) throws Exception
    {
    	if(in.equals(out)) return;
        out.getParentFile().mkdirs();
        
        FileInputStream fis = new FileInputStream(in);
        FileOutputStream fos = new FileOutputStream(out);
        
        FileChannel inputChannel = fis.getChannel();
        FileChannel outputChannel = fos.getChannel();
        
        outputChannel.transferFrom(inputChannel,0,in.length());
        
        fis.close();
        fos.close();
    }
    
    
    /*
     * formattage du file path pour correspondre  l'OS
     */
    public static String pathOS(String path)
    {
    	String s = File.separator;
    	path = path.replace("\\",s).replace("/",s).replace(s+s,s);
    	if(path.startsWith(s)) path = path.substring(1);
    	if(path.endsWith(s)) path = path.substring(0,path.length()-1);
    	return path;
    }
    
    public static File newFileOS(String path)
    {return new File(pathOS(path)).getAbsoluteFile();}
    
    public static File newFileOS(File dir, String path)
    {return new File(dir,pathOS(path)).getAbsoluteFile();}
    
    
    public static void initFile1(File file) throws Exception
	{if(file!=null && !file.exists()) file.createNewFile();}
	
    
	public static void initDir1(File dir) throws Exception
	{if(dir!=null && !dir.exists()) dir.mkdirs();}
    
    
    
    
    
    

    
    
    /*
     * FILE FILTER
     */
    private static class ExtFileFilter implements FileFilter
    {
        private String end;
        public ExtFileFilter(String ext) {end = "."+ext.toLowerCase();}
        public boolean accept(File f)
        {return f.isFile() && f.getName().toLowerCase().endsWith(end);}
    }
    
    private static class DirFileFilter implements FileFilter
    {
        public boolean accept(File f)
        {return f.isDirectory();}
    }
    
    private static FileFilter extFileFilter(String ext)
    {return new ExtFileFilter(ext);}
    
    public static FileFilter curFileFilter = extFileFilter("cur");
    public static FileFilter icoFileFilter = extFileFilter("ico");
    public static FileFilter pngFileFilter = extFileFilter("png");
    public static FileFilter gifFileFilter = extFileFilter("gif");
    public static FileFilter jarFileFilter = extFileFilter("jar");
    public static FileFilter zipFileFilter = extFileFilter("zip");
    public static FileFilter wavFileFilter = extFileFilter("wav");
    public static FileFilter lingFileFilter = extFileFilter("ling");
    public static FileFilter propFileFilter = extFileFilter("properties");
    public static FileFilter dirFileFilter = new DirFileFilter();
    
    
    
    
    /*
     * URL CONNECTION
     */
    public static URLConnection connect(URL url) throws Exception
    {
    	URLConnection con = url.openConnection();
    	con.connect();
    	return con;
    }

    public static void disconnect(URLConnection con)
    {
    	if(con!=null && con instanceof HttpURLConnection)
        ((HttpURLConnection)con).disconnect();
    }
    
    public static void close(Closeable c)
    {
    	try{if(c!=null)c.close();}
    	catch(IOException e){}
    }
    
    public static Properties prop(URL url) throws Exception
    {
    	URLConnection con = null;
    	InputStream is = null;
    	Properties prop = new Properties();
		
    	try
    	{
    		con = connect(url);
    		is = con.getInputStream();
    		prop.load(is);
    		close(is);
    		disconnect(con);
    	}
    	catch(IOException e)
    	{
    		close(is);
    		disconnect(con);
    		throw e;
    	}
		return prop;
    }
    
    public static String text(URL url) throws Exception
    {
    	URLConnection con = null;
    	InputStreamReader isr = null;
    	StringBuffer buffer = new StringBuffer();
        
    	try
    	{
    		con = connect(url);
    		InputStream is = con.getInputStream(); 
            isr = new InputStreamReader(is);
            int b;
            while((b = isr.read())!=-1)
            {buffer.append((char)b);}
            close(isr);
            disconnect(con);
    	}
    	catch(IOException e)
    	{
    		close(isr);
    		disconnect(con);
    		throw e;
    	}
        return buffer.toString();
    }
    
    
    
    
    
    
    
    /*
     * FILES READING
     */
    public static String text(InputStream is) throws Exception
    {
        StringBuffer b = new StringBuffer();
        int c;
        while((c=is.read())!=-1)
        b.append((char)c);
        is.close();
        return b.toString();
    }
    
    public static String text(File file) throws Exception
    {
    	if(!file.canRead()) throw new Exception("Cannot read file ["+file+"]");
    	FileReader fr = new FileReader(file);
        char[] a = new char[(int)file.length()];
        fr.read(a,0,(int)file.length());
        fr.close();
        return new String(a);
    }
    
    public static Properties prop(InputStream is) throws Exception
    {
    	Properties prop = new Properties();
        prop.load(is);
        is.close();
        return prop;
    }
    
    public static Properties prop(File file) throws Exception
    {
    	if(!file.canRead()) throw new Exception("Cannot read file ["+file+"]");
    	return prop(new FileInputStream(file));
    }
    
    
    
    
    /*
     * FILES WRITING
     */
    public static void writeText(File file, String text) throws Exception
    {
    	PrintStream p = new PrintStream(file);
    	p.print(text);
    	p.close();
    }
    
    public static void writeSet(File file, Transform t, Set set) throws Exception
    {
    	PrintStream p = new PrintStream(file);
    	Tool_storeArray.printSet(p,t,set);
    }

    public static void writeList(File file, Transform t, List list) throws Exception
    {
    	PrintStream p = new PrintStream(file);
    	Tool_storeArray.printList(p,t,list);
    }
    
    public static void writeMap(File file, Map map) throws Exception
    {
    	Properties prop = toProp(map);
    	FileOutputStream fos = new FileOutputStream(file);
    	prop.store(fos,"");
    	fos.close();
    }
    
    
    
    
    
    
    
    
    
    /*
     * MAP
     */
    public static void increase(Map m, String key)
    {
    	Integer n = m.containsKey(key)?(Integer)m.get(key):new Integer(0);
    	n = new Integer(n.intValue()+1);
    	m.put(key,n);
    }
    
    public static void keepMax(Map m, String key, long value)
    {
    	if(m.containsKey(key))
    	{
    		Long l = (Long)m.get(key);
    		value = Math.max(value,l.longValue());
    	}
    	m.put(key,new Long(value));
    }
    
    public static void keepSum(Map m, String key, long value)
    {
    	Long l = m.containsKey(key)?(Long)m.get(key):new Long(0);
    	l = new Long(l.intValue()+value);
    	m.put(key,l);
    }
    
    public static Properties toProp(Object obj) throws Exception
    {
    	if(obj instanceof Properties) return (Properties) obj;
    	if(obj instanceof Map)
    	{
    		Properties prop = new Properties();
    		prop.putAll((Map)obj);
    		return prop;
    	}
    	throw new Exception("Invalid data: "+obj);
    }
    
    
    
    
    
    /*
     * COLLECTION
     */
    public static List list(String text, Transform t) throws Exception
    {return Tool_storeArray.list(text,t);}
    
    public static List list(URL url, Transform t) throws Exception
    {return list(text(url),t);}
    
    public static List list(File file, Transform t) throws Exception
    {return list(text(file),t);}
    
    public static List list(InputStream is, Transform t) throws Exception
    {return list(text(is),t);}

    
    
    public static Set set(String text, Transform t) throws Exception
    {return Tool_storeArray.set(text,t);}
    
    public static Set set(URL url, Transform t) throws Exception
    {return set(text(url),t);}
    
    public static Set set(File file, Transform t) throws Exception
    {return set(text(file),t);}
    
    public static Set set(InputStream is, Transform t) throws Exception
    {return set(text(is),t);}
    
    
    
    
    
    
    
    
    
    
    /*
     * FILTER
     */
    public static TrueFilter trueFilter = new TrueFilter();
    public static FalseFilter falseFilter = new FalseFilter();
    
    private static class TrueFilter implements Filter
    {public boolean filter(Object obj) throws Exception {return true;}}
    
    private static class FalseFilter implements Filter
    {public boolean filter(Object obj) throws Exception {return false;}}
    
    
    public static Filter filterCol(Collection c){return new FilterCol(c);}
    public static Filter filterMap(Map m){return new FilterMap(m);}
    
    private static class FilterCol implements Filter
    {
    	private Collection c;FilterCol(Collection c){this.c=c;}
		public boolean filter(Object obj) throws Exception
		{return c.contains(obj);}
    }
    
    private static class FilterMap implements Filter
    {
    	private Map m;FilterMap(Map m){this.m=m;}
		public boolean filter(Object obj) throws Exception
		{return m.containsKey(obj);}
    }
    
    
    
    
    
    /*
     * TRANSFORM
     */
    public static IdTransform idTransform = new IdTransform();
    
    private static class IdTransform implements Transform
    {public Object transform(Object obj) throws Exception{return obj;}}
    
    
    public static Map applyTransform(Map map, Transform t) throws Exception
    {
    	HashMap map1 = new HashMap();
		Iterator it = map.keySet().iterator();
		while(it.hasNext())
		{
			Object key = it.next();
			Object value = map.get(key);
			map1.put(t.transform(key),t.transform(value));
		}
		return map1;
    }
    
    public static List applyTransform(List list, Transform t) throws Exception
    {
    	List list1 = new ArrayList();
    	for(int i=0;i<list.size();i++)
		list1.add(t.transform(list.get(i)));
		return list1;
    }
    
    public static Set applyTransform(Set set, Transform t) throws Exception
    {
    	HashSet set1 = new HashSet();
		Iterator it = set.iterator();
		while(it.hasNext())
		set1.add(t.transform(it.next()));
		return set1;
    }
    
    
    
    
    
    
    /*
     * GRAPHIC
     */
    public static PanelGraphic panelGraphic = new PanelGraphic();
    
    private static class PanelGraphic implements Graphic
    {public JComponent gui(){return new JPanel();}}
    

	public static JComponent scroll(JComponent c)
	{
		if(c instanceof Scrollable) return new JScrollPane(c);
		return c;
	}
    
	
	
	
	public static GraphicsDevice graphicsDevice()
	{
		GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
		return ge.getDefaultScreenDevice();
	}
	
	public static GraphicsConfiguration graphicsConfiguration()
	{
		return graphicsDevice().getDefaultConfiguration();
	}
	
	

	public static Image iconToImage(Icon icon)
	{
		if(icon==null) return null;
    	if(icon instanceof ImageIcon) return ((ImageIcon)icon).getImage();

		int w = icon.getIconWidth();
		int h = icon.getIconHeight();
		
		BufferedImage image = graphicsConfiguration().createCompatibleImage(w,h,Transparency.BITMASK);
		Graphics2D g = image.createGraphics();
		icon.paintIcon(null,g,0,0);
		g.dispose();
		return image;
	} 
    
    
    
	
    /*
     * PRINTSTREAM
     */
    
    private static class OutputStreamNull extends OutputStream
    {
        public OutputStreamNull(){} 
        public void write(int b){}
    }
    
    public static final OutputStreamNull nullOutput = new OutputStreamNull();
    public static final PrintStream nullPrintStream = new PrintStream(nullOutput);
    
    
    
    
    /*
     * LANGUAGE COUNTRY
     */
    
    public static boolean isISO639_LanguageCode(String code)
    {
    	String[] codes = Locale.getISOLanguages();
    	for(int i=0;i<codes.length;i++)
    		if(codes[i].equals(code)) return true;
    	return false;
    }
    
    public static boolean isISO3166_CountryCode(String code)
    {
    	String[] codes = Locale.getISOCountries();
    	for(int i=0;i<codes.length;i++)
    		if(codes[i].equals(code)) return true;
    	return false;
    }
}
