package gus05.manager.gus.kassia.layer3;


import java.applet.AudioClip;
import java.io.File;
import java.io.InputStream;
import java.io.PrintStream;
import java.net.URL;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.crypto.SecretKey;
import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.tree.TreeModel;

import gus05.framework.core.Entity;
import gus05.framework.features.*;
import gus05.framework.resources.FileProvider;
import gus05.framework.resources.StringProvider;



public class KS4 extends KS3 {

	
	protected static void s0_addLog(PrintStream out) throws Exception
	{
		Give g = poolgive(POOL_PRINTSTREAM_APP_LOG);
		if(g!=null) g.give(out);
	}

	protected static File s0_getFile(String key)
    {
		FileProvider fp = (FileProvider) getPool(POOL_FILEPROVIDER);
		return fp!=null?fp.getFile(key):null;
	}
	
	protected static File s0_getFilePool(String key)
    {
		FileProvider fp = (FileProvider) getPool(POOL_FILEPROVIDER_POOL);
		return fp!=null?fp.getFile(key):null;
	}
	
	protected static String s0_getLingString(String key)
	{
		StringProvider sp = (StringProvider) getPool(POOL_STRINGPROVIDER_LING);
		return sp!=null?sp.getString(key):key;
	}
	
	protected static void s0_initFile(File file) throws Exception
	{
		if(file==null || file.exists()) return;
		Register fi = poolreg(POOL_REGISTER_FILEINITIALIZER);
    	if(fi!=null) fi.register("file",file);
    	else file.createNewFile();
	}
	
	protected static void s0_initDir(File dir) throws Exception
	{
		if(dir==null || dir.exists()) return;
		Register fi = poolreg(POOL_REGISTER_FILEINITIALIZER);
    	if(fi!=null) fi.register("dir",dir);
    	else dir.mkdirs();
	}
	
	protected static void s0_handleAction(Action action) throws Exception
	{

		Give g = poolgive(POOL_GIVE_ACTIONHANDLER);
		if(g!=null) g.give(action);
	}
	
	protected static void s0_updateAction(Action action) throws Exception
	{
		Give g = poolgive(POOL_GIVE_ACTIONUPDATER);
		if(g!=null) g.give(action);
	}
	
    protected static Entity s0_generateEntity(String name) throws Exception
	{
		Retrieve ret = poolret(POOL_RETRIEVE_ENTITYGENERATOR);
		if(ret==null) return createInternalEntity(name);
		Entity entity = (Entity) ret.retrieve(name);
		if(entity==null) throw new Exception("Entity generator returned null for entity: ["+name+"]");
    	return entity;
	}
	
    protected static void s0_loadEntity(String name) throws Exception
    {
    	Give g = poolgive(POOL_GIVE_ENTITYLOADER);
        if(g!=null) g.give(name);
    }
	
    protected static void s0_checkLoadSecurity(String name) throws Exception
	{
		if(hasArg(ARGVALUE_DISABLEENTITYSECURITY)) return;
		Give g = poolgive(POOL_GIVE_ENTITYLOADSECURITY);
		if(g!=null) g.give(name);
	}
	
    protected static void s0_loadEntityParam(String name) throws Exception
	{
		Give g = poolgive(POOL_GIVE_ENTITYPARAMLOADER);
    	if(g!=null) g.give(name);
	}

    protected static void s0_persistData(String id) throws Exception
	{
		Give g = poolgive(POOL_GIVE_DATAPERSISTENCE);
		if(g!=null) g.give(id);
	}
	
    protected static void s0_backupData(String id) throws Exception
	{
		Give g = poolgive(POOL_GIVE_DATABACKUP);
		if(g!=null) g.give(id);
	}

    protected static void s0_handleLastError(Object info) throws Exception
	{
		Give g = poolgive(POOL_GIVE_LASTERRORHANDLER);
		if(g!=null) g.give(info);
	}
	
	
    
	
	
    
    
    protected static Icon s1_buildIcon(String key, Object source) throws Exception
    {
    	checkPool(POOL_TRANSFORM_ICONBUILDER);
    	return (Icon) pooltran(POOL_TRANSFORM_ICONBUILDER).transform(new Object[]{key,source});
    }
    
    protected static AudioClip s1_buildSound(String key, Object source) throws Exception
    {
    	checkPool(POOL_TRANSFORM_SOUNDBUILDER);
    	return (AudioClip) pooltran(POOL_TRANSFORM_SOUNDBUILDER).transform(new Object[]{key,source});
    }
	
    protected static void s1_loadIcon(String key, Object source) throws Exception
    {
    	checkPool(POOL_REGISTER_ICONLOADER);
    	poolreg(POOL_REGISTER_ICONLOADER).register(key,source);
    }
    
    protected static void s1_loadSound(String key, Object source) throws Exception
    {
    	checkPool(POOL_REGISTER_SOUNDLOADER);
    	poolreg(POOL_REGISTER_SOUNDLOADER).register(key,source);
    }
    
    protected static void s1_askExit() throws Exception
    {
    	checkPool(POOL_EXECUTE_EXIT);
    	poolexe(POOL_EXECUTE_EXIT).execute();
    }
    
    protected static void s1_forceExit() throws Exception
    {
    	removePool(POOL_FILTER_CONFIRMEXIT);
		removePool(POOL_OBJ_EXITTRIGGER);
		s1_askExit();
		throw new Exception("ExecuteExit dit not exit the application");
    }
    
	protected static String[] s1_buildActionInfos(Action action) throws Exception
	{
		checkPool(POOL_TRANSFORM_ACTIONINFOBUILDER);
		return (String[]) pooltran(POOL_TRANSFORM_ACTIONINFOBUILDER).transform(action);
	}
    
    protected static Entity s1_provideUniqueEntity(String name) throws Exception
	{
    	checkPool(POOL_RETRIEVE_ENTITYPROVIDER1);
		Entity entity = (Entity) poolret(POOL_RETRIEVE_ENTITYPROVIDER1).retrieve(name);
		if(entity==null) throw new Exception("Entity provider 1 returned null for entity: ["+name+"]");
    	return entity;
	}
	
    protected static Entity s1_provideUniqueEntity(String name, String storeKey) throws Exception
	{
		checkPool(POOL_RETRIEVE_ENTITYPROVIDER2);
		Retrieve ret = poolret(POOL_RETRIEVE_ENTITYPROVIDER2);
		((Register)ret).register("entityName",name);
		Entity entity = (Entity) ret.retrieve(storeKey);
		if(entity==null) throw new Exception("Entity provider 2 returned null for entity: ["+name+"]");
    	return entity;
	}
	
    protected static Entity s1_provideEntity(String name) throws Exception
	{
		checkPool(POOL_RETRIEVE_ENTITYPROVIDER3);
		Entity entity = (Entity) poolret(POOL_RETRIEVE_ENTITYPROVIDER3).retrieve(name);
		if(entity==null) throw new Exception("Entity provider 3 returned null for entity: ["+name+"]");
    	return entity;
	}
    
    protected static Class s1_retrieveEntityClass(String name) throws Exception
    {
		checkPool(POOL_RETRIEVE_ENTITYCLASSHOLDER);
    	Class c = (Class) poolret(POOL_RETRIEVE_ENTITYCLASSHOLDER).retrieve(name);
    	if(c==null) throw new Exception("Class not found for entity: ["+name+"]");
    	return c;
    }
    
    protected static void s1_loadEntity(String name) throws Exception
    {	
		checkPool(POOL_GIVE_ENTITYLOADER);
		poolgive(POOL_GIVE_ENTITYLOADER).give(name);
    }
    
    protected static Class s1_loadEntityClass(String name) throws Exception
	{
		checkPool(POOL_RETRIEVE_ENTITYCLASSLOADER);
        Class c = (Class) poolret(POOL_RETRIEVE_ENTITYCLASSLOADER).retrieve(name);
        if(c==null) throw new Exception("Unknown entity: ["+name+"]");
        return c;
	}
	
    protected static Class s1_loadEntityClass_jar(String name, File jar) throws Exception
	{
		checkPool(POOL_TRANSFORM_ENTITYCLASSLOADER_JAR);
        Retrieve ret = (Retrieve) pooltran(POOL_TRANSFORM_ENTITYCLASSLOADER_JAR).transform(jar);
		if(ret==null) throw new Exception("Jar entity class loader returned a null value");
		return (Class) ret.retrieve(name);
	}
	
    protected static Class s1_loadEntityClass_bin(String name, File bin) throws Exception
	{
		checkPool(POOL_TRANSFORM_ENTITYCLASSLOADER_BIN);
		Retrieve ret = (Retrieve) pooltran(POOL_TRANSFORM_ENTITYCLASSLOADER_BIN).transform(bin);
		if(ret==null) throw new Exception("Bin entity class loader returned a null value");
		return (Class) ret.retrieve(name);
	}
	
    protected static void s1_buildData(String id) throws Exception
	{
		checkPool(POOL_GIVE_DATABUILDER);
		poolgive(POOL_GIVE_DATABUILDER).give(id);
	}
	
    protected static Object s1_findDataSource(String name) throws Exception
	{
		checkPool(POOL_RETRIEVE_DATASOURCEFINDER);
		return poolret(POOL_RETRIEVE_DATASOURCEFINDER).retrieve(name);
	}
	
    private static Object s1_getData(String id) throws Exception
	{
		checkPool(POOL_RETRIEVE_DATAPROVIDER);
		return poolret(POOL_RETRIEVE_DATAPROVIDER).retrieve(id);
	}
	
    protected static JComponent s1_provideMainGui() throws Exception
	{
		checkPool(POOL_PROVIDE_MAINGUIBUILDER);
		return (JComponent) poolpro(POOL_PROVIDE_MAINGUIBUILDER).provide();
	}
    
    protected static SecretKey s1_buildSecretKey() throws Exception
	{
		checkPool(POOL_PROVIDE_SECRETKEYBUILDER);
		return (SecretKey) poolpro(POOL_PROVIDE_SECRETKEYBUILDER).provide();
	}
    
    protected static String s1_encodeBase64(byte[] input) throws Exception
	{
		checkPool(POOL_TRANSFORM_BASE64ENCODER);
		return (String) pooltran(POOL_TRANSFORM_BASE64ENCODER).transform(input);
	}
	
    protected static byte[] s1_decodeBase64(String input) throws Exception
	{
		checkPool(POOL_TRANSFORM_BASE64DECODER);
		return (byte[]) pooltran(POOL_TRANSFORM_BASE64DECODER).transform(input);
	}
    
    protected static Transform s1_Uencoder() throws Exception
	{
		checkPool(POOL_TRANSFORM_UENCODER);
		return pooltran(POOL_TRANSFORM_UENCODER);
	}
    
    protected static Transform s1_Udecoder() throws Exception
	{
		checkPool(POOL_TRANSFORM_UDECODER);
		return pooltran(POOL_TRANSFORM_UDECODER);
	}
    
    protected static Transform s1_cipher() throws Exception
	{
		checkPool(POOL_TRANSFORM_CIPHER);
		return pooltran(POOL_TRANSFORM_CIPHER);
	}
    
    protected static Transform s1_decipher() throws Exception
	{
		checkPool(POOL_TRANSFORM_DECIPHER);
		return pooltran(POOL_TRANSFORM_DECIPHER);
	}
    
    
    
    
    
    
    protected static List s1_getDataList(String id) throws Exception
	{return (List) s1_getData(id);}
	
    protected static Set s1_getDataSet(String id) throws Exception
	{return (Set) s1_getData(id);}
	
    protected static Map s1_getDataMap(String id) throws Exception
	{return (Map) s1_getData(id);}
	
    protected static TreeModel s1_getDataTree(String id) throws Exception
	{return (TreeModel) s1_getData(id);}
    
    
    
    
    protected static String s1_encodeU(String input) throws Exception
	{return (String) s1_Uencoder().transform(input);}
    
    protected static Set s1_encodeU_set(Set input) throws Exception
    {return applyTransform(input,s1_Uencoder());}
    
    protected static List s1_encodeU_list(List input) throws Exception
    {return applyTransform(input,s1_Uencoder());}
    
    
    
    
    protected static String s1_decodeU(String input) throws Exception
	{return (String) s1_Udecoder().transform(input);}
    
    protected static Set s1_decodeU_set(Set input) throws Exception
    {return applyTransform(input,s1_Udecoder());}
    
    protected static List s1_decodeU_list(List input) throws Exception
    {return applyTransform(input,s1_Udecoder());}
    
    
    

    
    protected static String s1_cipher(String input) throws Exception
	{return (String) s1_cipher().transform(input);}
	
	protected static Set s1_cipherSet(Set set) throws Exception
    {return applyTransform(set,s1_cipher());}
	
	protected static List s1_cipherList(List list) throws Exception
    {return applyTransform(list,s1_cipher());}
    
	protected static Map s1_cipherMap(Map map) throws Exception
    {return applyTransform(map,s1_cipher());}
	
	
	
	
	
    protected static String s1_decipher(String input) throws Exception
	{return (String) s1_decipher().transform(input);}
	
	protected static Set s1_decipherSet(Set set) throws Exception
    {return applyTransform(set,s1_decipher());}
	
	protected static List s1_decipherList(List list) throws Exception
    {return applyTransform(list,s1_decipher());}
	
	protected static Map s1_decipherMap(Map map) throws Exception
    {return applyTransform(map,s1_decipher());}
	
	
	

	
	
	/*
	 * READING TEXT U
	 */
	protected static String readTextU(String text) throws Exception
    {return s1_decodeU(text);}
    
	protected static String readTextU(InputStream is) throws Exception
    {return s1_decodeU(text(is));}
    
	protected static String readTextU(File file) throws Exception
    {return s1_decodeU(text(file));}
	
	protected static String readTextU(URL url) throws Exception
    {return s1_decodeU(text(url));}
	/*
	 * READING SET U
	 */
	protected static Set readSetU(String text) throws Exception
    {return set(text,s1_Udecoder());}
    
	protected static Set readSetU(InputStream is) throws Exception
    {return set(is,s1_Udecoder());}
    
	protected static Set readSetU(File file) throws Exception
    {return set(file,s1_Udecoder());}
    
	protected static Set readSetU(URL url) throws Exception
    {return set(url,s1_Udecoder());}
	/*
	 * READING LIST U
	 */
	protected static List readListU(String text) throws Exception
    {return list(text,s1_Udecoder());}
    
	protected static List readListU(InputStream is) throws Exception
    {return list(is,s1_Udecoder());}
    
	protected static List readListU(File file) throws Exception
    {return list(file,s1_Udecoder());}
	
    protected static List readListU(URL url) throws Exception
    {return list(url,s1_Udecoder());}
	/*
	 * READING MAP U
	 */
    //PAS ENCORE FAIT
//    protected static Map readMapU(String text) throws Exception
//    {return prop(text);}
    
    protected static Map readMapU(InputStream is) throws Exception
    {return prop(is);}
	
    protected static Map readMapU(File file) throws Exception
    {return prop(file);}
	
    protected static Map readMapU(URL url) throws Exception
    {return prop(url);}
	
    
	/*
	 * READING TEXT U (ENCRYPTED)
	 */
    protected static String readTextU_C(String text) throws Exception
    {return s1_decipher(readTextU(text));}
	
    protected static String readTextU_C(InputStream is) throws Exception
    {return s1_decipher(readTextU(is));}
	
	protected static String readTextU_C(File file) throws Exception
    {return s1_decipher(readTextU(file));}
	
	protected static String readTextU_C(URL url) throws Exception
    {return s1_decipher(readTextU(url));}
	/*
	 * READING SET U (ENCRYPTED)
	 */
	protected static Set readSetU_C(String text) throws Exception
    {return s1_decipherSet(readSetU(text));}
	
    protected static Set readSetU_C(InputStream is) throws Exception
    {return s1_decipherSet(readSetU(is));}
	
	protected static Set readSetU_C(File file) throws Exception
    {return s1_decipherSet(readSetU(file));}
    
	protected static Set readSetU_C(URL url) throws Exception
    {return s1_decipherSet(readSetU(url));}
	/*
	 * READING LIST U (ENCRYPTED)
	 */
	protected static List readListU_C(String text) throws Exception
    {return s1_decipherList(readListU(text));}
	
    protected static List readListU_C(InputStream is) throws Exception
    {return s1_decipherList(readListU(is));}
	
	protected static List readListU_C(File file) throws Exception
    {return s1_decipherList(readListU(file));}

	protected static List readListU_C(URL url) throws Exception
    {return s1_decipherList(readListU(url));}
	/*
	 * READING MAP U (ENCRYPTED)
	 */
//	protected static Map readMapU_C(String text) throws Exception
//    {return s1_decipherMap(readMapU(text));}
	
    protected static Map readMapU_C(InputStream is) throws Exception
    {return s1_decipherMap(readMapU(is));}
	
	protected static Map readMapU_C(File file) throws Exception
    {return s1_decipherMap(readMapU(file));}
	
	protected static Map readMapU_C(URL url) throws Exception
    {return s1_decipherMap(readMapU(url));}
	
	
	
	
	/*
	 * WRITING
	 */
	protected static void writeTextU(File file, String text) throws Exception
    {writeText(file,s1_encodeU(text));}
    
	protected static void writeSetU(File file, Set set) throws Exception
	{writeSet(file,s1_Uencoder(),set);}

	protected static void writeListU(File file, List list) throws Exception
    {writeList(file,s1_Uencoder(),list);}

	protected static void writeMapU(File file, Map map) throws Exception
    {writeMap(file,map);}
    
	
	/*
	 * WRITING (ENCRYPTED)
	 */
	protected static void writeTextU_C(File file, String text) throws Exception
    {writeTextU(file,s1_cipher(text));}
	
	protected static void writeSetU_C(File file, Set set) throws Exception
    {writeSetU(file,s1_cipherSet(set));}

	protected static void writeListU_C(File file, List list) throws Exception
    {writeListU(file,s1_cipherList(list));}
    
	protected static void writeMapU_C(File file, Map map) throws Exception
    {writeMapU(file,s1_cipherMap(map));}
}
