package gus05.manager.gus.kassia.layer3;

import gus05.framework.core.Entity;
import gus05.framework.tools.DefaultSupport;

import java.applet.AudioClip;
import java.io.File;
import java.io.PrintStream;
import java.net.URL;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.swing.Icon;
import javax.swing.JFrame;
import javax.swing.JMenuBar;


public class KS5 extends KS4 {

	
	protected static Map map_props()					{return poolmap(POOL_MAP_PROPS);}
	protected static Map map_files()					{return poolmap(POOL_MAP_FILES);}
	protected static Map map_icons()					{return poolmap(POOL_MAP_ICONS);}
	protected static Map map_sounds()					{return poolmap(POOL_MAP_SOUNDS);}
	protected static Map map_lings()					{return poolmap(POOL_MAP_LINGS);}
	protected static Map map_actions()					{return poolmap(POOL_MAP_ACTIONS);}
	protected static Map map_providers()				{return poolmap(POOL_MAP_PROVIDERS);}
	protected static Map map_multiplicity()				{return poolmap(POOL_MAP_ENTITYMULTIPLICITY);}
	protected static Map map_entityOrigines()			{return poolmap(POOL_MAP_ENTITYORIGINES);}
	protected static Map map_entityClasses()			{return poolmap(POOL_MAP_ENTITYCLASSES);}
	protected static Map map_entityInstances()			{return poolmap(POOL_MAP_ENTITYINSTANCES);}
	protected static Map map_instanceNumber()			{return poolmap(POOL_MAP_ENTITYINSTANCENUMBERS);}
	protected static Map map_creationDates()			{return poolmap(POOL_MAP_ENTITYCREATIONDATES);}
	protected static Map map_lastUsedDates()			{return poolmap(POOL_MAP_ENTITYLASTUSEDDATES);}
	protected static Map map_lastBuildTime()			{return poolmap(POOL_MAP_ENTITYLASTBUILDTIMES);}
	protected static Map map_maxBuildTime()				{return poolmap(POOL_MAP_ENTITYMAXBUILDTIMES);}
	protected static Map map_sumBuildTime()				{return poolmap(POOL_MAP_ENTITYSUMBUILDTIMES);}
	protected static Map map_creationTrack()			{return poolmap(POOL_MAP_ENTITYCREATIONTRACK);}
	protected static Map map_dataObject()				{return poolmap(POOL_MAP_DATAOBJECT);}
	protected static Map map_dataSource()				{return poolmap(POOL_MAP_DATASOURCE);}
	protected static Map map_const()					{return poolmap(POOL_MAP_CONSTANTS);}
	protected static Set set_languages()				{return poolset(POOL_SET_LANGUAGES);}
	protected static List iconIdList()					{return poollist(POOL_LIST_ICONIDS);}
	protected static List soundIdList()					{return poollist(POOL_LIST_SOUNDIDS);}
	protected static List startedList()					{return poollist(POOL_LIST_STARTEDENTITIES);}
	protected static DefaultSupport supportExit()		{return poolsup(POOL_SUPPORT_EXIT);}
	protected static DefaultSupport supportExit2()		{return poolsup(POOL_SUPPORT_EXIT2);}
	protected static DefaultSupport supportStart()		{return poolsup(POOL_SUPPORT_START);}
	protected static DefaultSupport supportLing()		{return poolsup(POOL_SUPPORT_LING);}
	protected static PrintStream p_log()				{return (PrintStream) getPool(POOL_PRINTSTREAM_APP_LOG);}
	protected static JFrame mainFrame()					{return (JFrame) getPool(POOL_JFRAME_APPFRAME);}
	protected static JMenuBar menuBar()					{return (JMenuBar) getPool(POOL_JMENUBAR_APPMENUBAR);}
	
	
	
	/*
	 * ARGUMENTS
	 */

	
	public static boolean sysout()		{return hasArgOrTrueParam(ARGVALUE_SYSOUT);}
	public static boolean debug()		{return hasArgOrTrueParam(ARGVALUE_DEBUG);}
	public static boolean console()		{return hasArgOrTrueParam(ARGVALUE_CONSOLE);}
    
	
	/*
     * PROPERTIES
     */
	public static boolean hasProp(String key)
    {return map_props().containsKey(key);}
    
	public static String getProp(String key)
    {return (String) map_props().get(key);}
    
	public static void setProp(String key, String value)
    {map_props().put(key,value);}
    
	public static void addProp(Map p)
    {map_props().putAll(p);}
    
	public static String getProp(String key, String defaultValue)
    {return hasProp(key)? getProp(key):defaultValue;}
    
	public static String getProp_u(String key)
    {return getProp(key,"UNDEFINED");}
    
	public static boolean booleanProp(String key, boolean defaultValue)
    {return hasProp(key)? getProp(key).equalsIgnoreCase("true"):defaultValue;}
    
	public static int intProp(String key, int defaultValue)
    {return hasProp(key)? Integer.parseInt(getProp(key)):defaultValue;}
    
	public static long longProp(String key, long defaultValue)
    {return hasProp(key)? Long.parseLong(getProp(key)):defaultValue;}

	public static URL urlProp(String key) throws Exception
    {return hasProp(key)? new URL(getProp(key)):null;}
	
    
    
    
    
	public static String getDefaultMultiplicity()
	{return getProp(PROPKEY_DEFAULTMULTIPLICITY,MULTIPLICITYVALUE_DEFAULT);}
	
	public static String getDefaultProviderID()
	{return getProp(PROPKEY_DEFAULTPROVIDER,PROVIDERVALUE_DEFAULT);}
    
	public static boolean isSoundEnabled()
    {return booleanProp(PROPKEY_APPSOUNDENABLED,true);}
    
	public static boolean isSoundLazyLoad()
    {return booleanProp(PROPKEY_SOUND_LAZYLOAD,false);}
    
	public static boolean isIconLazyLoad()
    {return booleanProp(PROPKEY_ICON_LAZYLOAD,false);}
	
	public static boolean isActionThread()
    {return booleanProp(PROPKEY_ACTIONTHREAD,false);}
	
	public static String getSecretKeySpec(String defaultValue)
    {return getProp(PROPKEY_SECRETKEYSPEC,defaultValue);}
    
	public static String getErrorPrintLevel()
    {return getProp(PROPKEY_ERRORPRINTLEVEL,PROPDEFAULTVALUE_ERRORPRINTLEVEL);}
    
	public static String getErrorPrintLevel_first()
    {return getProp(PROPKEY_ERRORPRINTLEVEL_FIRST,PROPDEFAULTVALUE_ERRORPRINTLEVEL_FIRST);}
    
	public static String getErrorPrintLevel_exit()
    {return getProp(PROPKEY_ERRORPRINTLEVEL_EXIT,PROPDEFAULTVALUE_ERRORPRINTLEVEL_EXIT);}
    
	public static int getErrorLimit()
    {return intProp(PROPKEY_ERRORLIMIT,-1);}
    
	public static String getPathCreationLevel()
    {return getProp(PROPKEY_PATHCREATIONLEVEL,PROPDEFAULTVALUE_PATHCREATIONLEVEL);}
    
	public static String appTitle()
	{return getProp_u(PROPKEY_APPTITLE);}
	
	public static String appName()
	{return getProp_u(PROPKEY_APPNAME);}
	
	public static String appVersion()
	{return getProp_u(PROPKEY_APPVERSION);}
	
	public static String appBuild()
	{return getProp_u(PROPKEY_APPBUILD);}
	
	public static String appGus05ID()
	{return appName()+"|"+appVersion()+"|"+appBuild();}
	
	
    
	
	
	
	
    
    
    
	/*
	 * FILE IDS
	 */
	protected static void putFile(String key, File f)
    {map_files().put(key,f);}
	
	protected static File getFile_pool(Entity entity, String id)
    {return s0_getFilePool(src(entity,id)+".txt");}
	
	protected static File getDir_pool(Entity entity, String id)
    {return s0_getFilePool(src(entity,id));}
	
	
	
	
	
	
	/*
	 * SOUND
	 */
	protected static boolean hasSound(String key)
	{
		if(key==null || key.equals("")) return false;
		return map_sounds().containsKey(key);
	}
	
	protected static AudioClip sound(String key)
    {
		if(!hasSound(key)) return null;
		return (AudioClip) map_sounds().get(key);
	}
	
	protected static AudioClip sound(Entity entity, String key)
    {
		AudioClip s = sound(src(entity,key));
		return s!=null?s:sound(key);
	}

	
	
	
	
	/*
	 * ICON
	 */
	protected static boolean hasIcon(String key)
	{
		if(key==null || key.equals("")) return false;
		return map_icons().containsKey(key);
	}
	
	protected static Icon icon(String key)
    {
		if(!hasIcon(key)) return null;
		return (Icon) map_icons().get(key);
	}
	
	protected static Icon icon(String entityName, String key)
    {
		Icon i = icon(src(entityName,key));
		return i!=null?i:icon(key);
	}
	
	protected static Icon icon(Entity entity, String key)
    {
		Icon i = icon(src(entity,key));
		return i!=null?i:icon(key);
	}
	
	protected static boolean hasIcon(String entityName, String key)
	{
		if(hasIcon(src(entityName,key))) return true;
		return hasIcon(key);
	}
	
	/*
	 * ICON 1
	 */
	protected static Icon icon1(String key)
    {
		Icon i = icon(key);
		return i!=null?i:icon(ICONID_DEFAULT);
	}
	
	protected static Icon icon1(String entityName, String key)
    {
		Icon i = icon(entityName,key);
		return i!=null?i:icon(ICONID_DEFAULT);
	}
	
	protected static Icon icon1(Entity entity, String key)
    {
		Icon i = icon(entity,key);
		return i!=null?i:icon(ICONID_DEFAULT);
	}
	
	
	/*
	 * LING
	 */
	protected static String getLingString(String entityName, String key)
	{
		String src = src(entityName,key);
		String s = s0_getLingString(src);
		return !s.equals(src)?s:s0_getLingString(key);
	}
	
	protected static String getLingString(Entity entity, String key)
	{
		String src = src(entity,key);
		String s = s0_getLingString(src);
		return !s.equals(src)?s:s0_getLingString(key);
	}
	
	protected static boolean hasLing(String key)
	{
		return !s0_getLingString(key).equals(key);
	}
	
	protected static boolean hasLing(String entityName, String key)
	{
		if(hasLing(src(entityName,key))) return true;
		return hasLing(key);
	}
	
	protected static boolean hasLing(Entity entity, String key)
	{
		if(hasLing(src(entity,key))) return true;
		return hasLing(key);
	}
	
	
	
	/*
	 * MULTIPLICITY
	 */
	protected static String getMultiplicity(String name)
	{
		Map m = map_multiplicity();
		if(m==null || !m.containsKey(name)) return getDefaultMultiplicity();
		return (String) m.get(name);
	}
	
	protected static boolean isMultiple(String name)
	{return getMultiplicity(name).equals(MULTIPLICITYVALUE_MULTIPLE);}
	
	
	protected static boolean isUnique(String name)
	{return getMultiplicity(name).equals(MULTIPLICITYVALUE_UNIQUE);}
}
