package gus05.manager.gus.kassia.layer3;



public class KS6 extends KS5 {
	
	/*
	 * APPLICATION PHASES
	 */
	private static int phase = 0;
	
	private static void nextPhase(int nextPhase, String title)
    {
		phase = nextPhase;
    	println("");
    	println("PHASE "+phase+": "+title);
    }
	
	public static void nextPhase_poolInitialization()
	{nextPhase(PHASE_POOLINITIALISATION,"POOL INITIALIZATION");}
	
	public static void nextPhase_applicationBuild()
	{nextPhase(PHASE_APPLICATIONBUILD,"APPLICATION BUILD");}
	
	public static void nextPhase_applicationStart()
	{nextPhase(PHASE_APPLICATIONSTART,"APPLICATION START");}
	
	public static void nextPhase_applicationSummary()
	{nextPhase(PHASE_APPLICATIONSUMMARY,"APPLICATION SUMMARY");}
	
	public static void nextPhase_applicationRuntime()
	{nextPhase(PHASE_APPLICATIONRUNTIME,"APPLICATION RUNTIME");}
	
	public static void nextPhase_applicationExit()
	{nextPhase(PHASE_APPLICATIONEXIT,"APPLICATION EXIT");}
	
	public static boolean isPhase_poolInitialization()		{return phase==PHASE_POOLINITIALISATION;}
	public static boolean isPhase_applicationBuild()		{return phase==PHASE_APPLICATIONBUILD;}
	public static boolean isPhase_applicationStart()		{return phase==PHASE_APPLICATIONSTART;}
	public static boolean isPhase_applicationSummary()		{return phase==PHASE_APPLICATIONSUMMARY;}
	public static boolean isPhase_applicationRuntime()		{return phase==PHASE_APPLICATIONRUNTIME;}
	public static boolean isPhase_applicationExit()			{return phase==PHASE_APPLICATIONEXIT;}
	
	
	protected static long startDuration;
	protected static long initpool_start;
	protected static long initpool_end;
	protected static long buildapp_start;
	protected static long buildapp_end;
	protected static long startapp_start;
	protected static long startapp_end;
    
    private static long t0 = -1;
    
    public static long lapse()
    {
    	long t = t0;
    	t0 = millis();
    	if(t==-1) return timeFromStart();
    	return t0-t;
    }
    
    
    
    protected static void println(String m)
	{p_log().println(m);}
    
    protected static void print(String type, Object source, String id, String message)
	{println(now()+" "+phase+" "+errorNumber()+" ["+type+"] "+name(source)+"@"+id+"\t"+message);}
	
    protected static void printM(Object source, String id, String message)
	{print("M",source,id,message);}
	
    protected static void printW(Object source, String id, String message)
	{print("W",source,id,message);}
	
    protected static void printE(Object source, String id, String message)
	{print("E",source,id,message);}
	
    protected static void printD(Object source, String id, String message)
	{if(debug())print("D",source,id,message);}
	
    
    
    
    protected static String javaVersionGap()
    {
    	if(!hasPool(POOL_STRINGARRAY_JAVAVERSIONGAP)) return "";
    	String[] gap = (String[]) getPool(POOL_STRINGARRAY_JAVAVERSIONGAP);
    	return " ("+gap[1]+" required)";
    }

	
	
	/*
	 * ELEMENT
	 */
    protected static Object findElement(String key) throws Exception
    {
    	if(hasPool(key)) return getPool(key);
    	String name = getProp(key,null);
        return name!=null?s1_provideUniqueEntity(name):null;
    }
    
    
    /*
     * EXIT
     */
	public static void askExit()
	{	
		try{s1_askExit();}
		catch(Exception e)
		{
			err(KS6.class,"askExit()",e);
			printW(KS6.class,"askExit()","Error occured during askExit(): System.exit(0)");
			EXIT_0();
		}
	}
	
	public static void forceExit()
	{	
		try{s1_forceExit();}
		catch(Exception e)
		{
			err(KS6.class,"forceExit()",e);
			printW(KS6.class,"forceExit()","Error occured during forceExit(): System.exit(0)");
			EXIT_0();
		}
	}
}
