package gus05.manager.gus.kassia.layer3.a02.initerrorlistener;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JOptionPane;

import gus05.manager.gus.kassia.layer3.KS6;

public class A02 extends KS6 implements ActionListener {

	
	private int previousErrorNumber;
	
	
	public static void initErrorListener() throws Exception
	{errors.addActionListener(new A02());}
	
	
	
	
	
	private A02() throws Exception
	{
		if(hasErrors())
			throw new Exception("Error list already contains "+errorNumber()+" elements");
		previousErrorNumber = 0;
	}
	
	
	
	public void actionPerformed(ActionEvent e)
	{errorListChanged();}
	
	
	
	
	
	
	private void errorListChanged()
    {
		if(errorNumber() == previousErrorNumber+1)
			handleLastestError();
		else
		{
			String w = "Errors list alteration detected: size has changed from "+previousErrorNumber+" to "+errorNumber();
			printW(this,"errorListChanged()",w);
		}

		int limit = getErrorLimit();
        if(limit!=-1) checkLimitExceeded(limit);
		previousErrorNumber = errorNumber();
    }
	
	
	
	
	
	
	private void handleLastestError()
	{
		Object[] info = getLastError();
		
		try{s0_handleLastError(info);}
		catch(Exception e)
		{
			printDefaultE(info);
			printE(this,"handleLastestError()","Unexpected error: "+e.toString());
		}
	}
	
	
	
	
	public void printDefaultE(Object[] info)
	{
		Object source = info[0];
        String id = (String) info[1];
        Exception e = (Exception) info[2];
        
        String exceptionName = e.getClass().getName();
        printE(source,id,exceptionName);
	}
	
	
	
	
	
	
	
	private void checkLimitExceeded(int limit)
	{
    	if(errorNumber() >= limit)
    	{
    		printW(this,"checkLimitExceeded()","Error limit exceeded: limit="+limit+" error number="+errorNumber());
    		printW(this,"checkLimitExceeded()","Exiting application");
    		
    		String message = "Too many errors have occurred: "+errorNumber()+"\nExiting application";
    		JOptionPane.showMessageDialog(null,message,"Exiting application",JOptionPane.ERROR_MESSAGE);
    		forceExit();
    	}
	}
}
