package gus05.manager.gus.kassia.layer3.a09.initfileprovider.pool;

import java.io.File;
import gus05.framework.resources.FileProvider;
import gus05.manager.gus.kassia.layer3.KS6;


public class A09 extends KS6 implements FileProvider {

	
	public static void initFileProvider_pool() throws Exception
	{putPool(POOL_FILEPROVIDER_POOL,new A09());}
	
	
	
	private File poolDir;
    private boolean initialized = false;
	
	
    
	public File getFile(String key)
    {
    	try
    	{
    		if(!initialized) initPoolDir();
        	if(poolDir==null) return null;
        	
        	String[] n = key.split("@",2);
        	if(n.length!=2) throw new Exception("Invalid key for pool file provider: ["+key+"]");
            	
        	File dataDir = newFileOS(poolDir,n[0]);
        	if(dataDir.isFile()) throw new Exception("Data dir path is a file: ["+dataDir+"]");
        	dataDir.mkdirs();
        	return newFileOS(dataDir,n[1]);
    	}
    	catch(Exception e)
    	{
			String message = "Failed to provide pool file with ID=["+key+"]";
			err(this,"getFile(String)",new Exception(message,e));
		}
    	return null;
    }
	
	
	
    
    private void initPoolDir()
    {
    	try
    	{
    		initialized = true;
            
    		File dir = s0_getFile(FILEID_POOLDIR);
            if(dir==null) throw new Exception("FileID "+FILEID_POOLDIR+" not found");
            
            if(!dir.exists()) s0_initDir(dir);
            if(!dir.exists()) throw new Exception("FileID "+FILEID_POOLDIR+" is not an existing path: ["+dir+"]");
            if(!dir.isDirectory()) throw new Exception("FileID "+FILEID_POOLDIR+" is not a directory path: ["+dir+"]");
            
            poolDir = dir;
    	}
    	catch(Exception e)
    	{err(this,"initPoolDir()",e);}
    }
}
