package gus05.manager.gus.kassia.layer3.a13.initcipher;

import java.security.AlgorithmParameters;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.spec.PBEParameterSpec;

import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer3.KS6;

public class A13 extends KS6 {

	
	private static final byte[] SALT  = new byte[] {0,0,0,0,0,0,0,0};
    private static final int ITERATION = 3;
	
	private static AlgorithmParameters params;
    private static Cipher cipher;
	
    
    
	public static void initCipher() throws Exception
	{
		params = AlgorithmParameters.getInstance("PBEWithMD5AndDES");
		params.init(new PBEParameterSpec(SALT,ITERATION));
		cipher = Cipher.getInstance("PBEWithMD5AndDES");
		
		putPool(POOL_TRANSFORM_CIPHER,new CipherTransform());
		putPool(POOL_TRANSFORM_DECIPHER,new DecipherTransform());
	}
	
	
	
    
	
	
	private static class CipherTransform implements Transform
	{
		public Object transform(Object obj) throws Exception
		{return perform_cipher((String)obj);}
	}
	
	private static class DecipherTransform implements Transform
	{
		public Object transform(Object obj) throws Exception
		{return perform_decipher((String)obj);}
	}
	

	
	private static String perform_cipher(String input) throws Exception
    {
		SecretKey key = s1_buildSecretKey();
    	byte[] inputBytes = input.getBytes();
    	
		cipher.init(Cipher.ENCRYPT_MODE,key,params);
		byte[] outputBytes = cipher.doFinal(inputBytes);
		
		return s1_encodeBase64(outputBytes);
    }
    

    
    private static String perform_decipher(String input) throws Exception
    {
    	SecretKey key = s1_buildSecretKey();
		byte[] inputBytes = s1_decodeBase64(input);
		
		cipher.init(Cipher.DECRYPT_MODE,key,params);
		byte[] outputBytes = cipher.doFinal(inputBytes);
		
		return new String(outputBytes);
    }
}
