package gus05.manager.gus.kassia.layer3.a15.initsoundbuilder;

import java.applet.AudioClip;
import java.net.URL;

import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer3.KS6;


public class A15 extends KS6 implements Transform {

	
	
	public static void initSoundBuilder()
    {
		putPoolList(POOL_LIST_SOUNDIDS);
        putPool(POOL_TRANSFORM_SOUNDBUILDER,new A15());
    }
	
	
	
	public Object transform(Object obj) throws Exception
	{
		Object[] data = (Object[]) obj;
		if(data.length!=2) throw new Exception("Wrong data number: "+data.length);
		String key = (String) data[0];
		Object source = data[1];
		
		return buildSound(key,source);
	}
    
    
    
    
    private AudioClip buildSound(String key, Object source) throws Exception
    {
    	if(source==null) throw new Exception("Null source for sound name: ["+key+"]");
        
    	if(source instanceof AudioClip) return (AudioClip) source;
    	if(source instanceof URL) return buildSound_URL(key,(URL)source);
    	
    	throw new Exception("Invalid source type: ["+source.getClass().getName()+"] for sound name: ["+key+"]");
    }
    
    
    
    private AudioClip buildSound_URL(String key, URL url)
    {
    	if(isSoundLazyLoad())
    		return new AudioClip0(key,url);
    	return new AudioClip1(key,url);
    }
    
    
    
    private class AudioClip0 implements AudioClip
    {
    	private URL url;
    	private String key;
        private AudioClip clip;
        
        public AudioClip0(String key, URL url)
        {
        	this.key = key;
        	this.url = url;
        }
        
        private void init()
        {if(clip==null)clip = loadAudioClip(key,url);}
        
        public void loop() {if(isSoundEnabled()){init(); clip.loop();}}
        public void play() {if(isSoundEnabled()){init(); clip.play();}}
        public void stop() {init(); clip.stop();}
    }
    
    
    
    
    private class AudioClip1 implements AudioClip
    {
    	private AudioClip clip;
        
        public AudioClip1(String key, URL url)
        {clip = loadAudioClip(key,url);}
        
        public void loop() {if(isSoundEnabled())clip.loop();}
        public void play() {if(isSoundEnabled())clip.play();}
        public void stop() {clip.stop();}
    }
    
    
    
    
    
    private AudioClip loadAudioClip(String key, URL url)
    {
    	AudioClip clip = loadAudioClip(url);
    	soundIdList().add(key);
    	return clip;
    }
}
