package gus05.manager.gus.kassia.layer3.b02.loadicons;

import java.io.File;
import java.net.URL;
import java.util.Iterator;
import java.util.Properties;
import java.util.Set;
import javax.swing.Icon;

import gus05.framework.resources.IconProvider;
import gus05.manager.gus.kassia.layer3.tools.AbstractResourceLoader;



public class B02 extends AbstractResourceLoader {

	
	
	public static void loadIcons() throws Exception
    {
        putPool(POOL_ICONPROVIDER1,new IconProvider(){
			public Icon getIcon(String key) {return icon1(key);}
		});
        putPool(POOL_ICONPROVIDER,new IconProvider(){
			public Icon getIcon(String key) {return icon(key);}
		});
        
        new B02().load("icon",PROPKEY_SEQUENCE_LOADICON,RESOURCEPATH_ICON);
    }
	
	
	
	

	protected void load_fromInside_(int index, String resourceID) throws Exception
	{
		Set set = insideListing(resourceID);
		if(set!=null)
		{
			Iterator it = set.iterator();
			while(it.hasNext())
			{
				String key = (String)it.next();
				URL url = insideURL(resourceID+"/"+key);
				String name = getResourceName(key);
				s1_loadIcon(name,url);
			}
		}
		
		Properties p = insideProp(resourceID+"_rules");
		if(p!=null) loadIcons_fromProp(p);
	}
    
    
    
    
	protected void load_fromPathID_(int index, String pathID) throws Exception
	{
		File f = s0_getFile(pathID);
		if(f!=null && f.exists())
		{
			if(f.isDirectory())	loadIcon_fromDir(f);
			else if(f.isFile())	loadIcon_fromFile(f);
		}
	}
    
    
    
    
    
    
    
    
    
    private void loadIcon_fromDir(File dir) throws Exception
    {
    	File[] gifs = dir.listFiles(gifFileFilter);
    	for(int i=0;i<gifs.length;i++) loadIcon_fromImageFile(gifs[i]);
    	
    	File[] pngs = dir.listFiles(pngFileFilter);
    	for(int i=0;i<pngs.length;i++) loadIcon_fromImageFile(pngs[i]);
    	
    	File[] icos = dir.listFiles(icoFileFilter);
    	for(int i=0;i<icos.length;i++) loadIcon_fromIcoFile(icos[i]);
    	
    	File[] curs = dir.listFiles(curFileFilter);
    	for(int i=0;i<curs.length;i++) loadIcon_fromIcoFile(curs[i]);

    	File[] props = dir.listFiles(propFileFilter);
    	for(int i=0;i<props.length;i++) loadIcons_fromPropFile(props[i]);
    }
    
    
    
    
    
    private void loadIcon_fromFile(File file) throws Exception
    {
    	if(gifFileFilter.accept(file))			loadIcon_fromImageFile(file);
		else if(pngFileFilter.accept(file)) 	loadIcon_fromImageFile(file);
		else if(icoFileFilter.accept(file)) 	loadIcon_fromIcoFile(file);
		else if(curFileFilter.accept(file)) 	loadIcon_fromIcoFile(file);
		else if(propFileFilter.accept(file)) 	loadIcons_fromPropFile(file);
    }
    
    
    
    
    
    private void loadIcon_fromImageFile(File f) throws Exception
    {
    	String name = getResourceName(f);
    	s1_loadIcon(name,f.toURI().toURL());
    }
    
    
    private void loadIcon_fromIcoFile(File f) throws Exception
    {
    	String name = getResourceName(f);
    	s1_loadIcon(name,f);
    }
    
    
    private void loadIcons_fromPropFile(File propFile) throws Exception
    {
    	Properties p = prop(propFile);
    	loadIcons_fromProp(p);
    }
    
    
    private void loadIcons_fromProp(Properties p) throws Exception
    {
    	Iterator it = p.keySet().iterator();
    	while(it.hasNext())
    	{
    		String key = (String) it.next();
    		String rule = p.getProperty(key);
    		s1_loadIcon(key,rule);
    	}
    }
}
