package gus05.manager.gus.kassia.layer3.b03.loadsounds;

import java.io.File;
import java.net.URL;
import java.util.Iterator;
import java.util.Set;

import gus05.manager.gus.kassia.layer3.tools.AbstractResourceLoader;


public class B03 extends AbstractResourceLoader {

	
	
	public static void loadSounds() throws Exception
    {
		new B03().load("sound",PROPKEY_SEQUENCE_LOADSOUND,RESOURCEPATH_SOUND);
	}
	
	
	
	

	protected void load_fromInside_(int index, String resourceID) throws Exception
	{
		Set set = insideListing(resourceID);
		if(set==null) return;

		Iterator it = set.iterator();
		while(it.hasNext())
		{
			String key = (String)it.next();
			URL url = insideURL(resourceID+"/"+key);
			String name = getResourceName(key);
			s1_loadSound(name,url);
		}
	}
    
    
    
    

	protected void load_fromPathID_(int index, String pathID) throws Exception
	{
		File f = s0_getFile(pathID);
		if(f!=null && f.exists())
		{
			if(f.isDirectory())
				loadSound_fromDir(f);
			else if(f.isFile())
			{
				if(wavFileFilter.accept(f)) loadSound_fromFile(f);
			}
		}
	}


    


    
    
    
    
    private void loadSound_fromDir(File dir) throws Exception
    {
    	File[] sounds = dir.listFiles(wavFileFilter);
    	for(int i=0;i<sounds.length;i++) loadSound_fromFile(sounds[i]);
    }
    
    
    
    private void loadSound_fromFile(File f) throws Exception
    {
    	String name = getResourceName(f);
    	URL url = f.toURI().toURL();
    	s1_loadSound(name,url);
    }
}
