package gus05.manager.gus.kassia.layer3.b04.loadlings;

import java.io.File;
import java.util.Iterator;
import java.util.Properties;
import java.util.Set;

import gus05.manager.gus.kassia.layer3.tools.AbstractResourceLoader;


public class B04 extends AbstractResourceLoader {

	
	
	public static void loadLings() throws Exception
	{
		putPoolMap(POOL_MAP_LINGS);
		putPoolSet(POOL_SET_LANGUAGES);
        
		new B04().load("ling",PROPKEY_SEQUENCE_LOADLING,RESOURCEPATH_LING);
	}
	
	
	
	
	protected void load_fromInside_(int index, String resourceID) throws Exception
	{
		Set set = insideListing(resourceID);
		if(set==null) return;

		Iterator it = set.iterator();
		while(it.hasNext())
		{
			String key = (String)it.next();
			Properties prop = insideProp(resourceID+"/"+key);
			String name = getResourceName(key);
			loadLing(name,prop);
		}
	}





	protected void load_fromPathID_(int index, String pathID) throws Exception
	{
		File f = s0_getFile(pathID);
		if(f!=null && f.exists())
		{
			if(f.isDirectory())
				loadLing_fromDir(f);
			else if(f.isFile())
			{
				if(lingFileFilter.accept(f)) loadLing_fromFile(f);
			}
		}
	}

    
    
    
    
    
    
    
    
    
    private void loadLing_fromDir(File dir) throws Exception
    {
    	File[] lings = dir.listFiles(lingFileFilter);
    	for(int i=0;i<lings.length;i++) loadLing_fromFile(lings[i]);
    }
    
    
    
    private void loadLing_fromFile(File f) throws Exception
    {
    	String name = getResourceName(f);
    	Properties prop = prop(f);
        loadLing(name,prop);
    }
    
    
    
    private void loadLing(String name, Properties prop)
    {
    	String lang = findLanguageExtension(name);
    	if(!isISO639_LanguageCode(lang))
    	{
    		String m = "Invalid ling resource name: ["+name+"] ("+lang+" is not ISO639)";
    		printW(this,"loadLing(String,Properties)",m);
    		return;
    	}
    	
        Iterator it = prop.keySet().iterator();
        while(it.hasNext())
        {
            String key = (String)it.next();
            String value = prop.getProperty(key);
            
            map_lings().put(key+"_"+lang,value);
            set_languages().add(lang);
        }
    }
    
    
    
    private String findLanguageExtension(String value)
    {
        String[] n = value.split("_",-1);
        return n[n.length-1];
    }
}
