package gus05.manager.gus.kassia.layer3.c01.initentityproviders;

import java.util.Map;

import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer3.KS6;

public class C01 extends KS6 {

	
	
	
	public static void initEntityProviders() throws Exception
    {
        putPoolMap(POOL_MAP_ENTITYINSTANCES);
        
        putPool(POOL_RETRIEVE_ENTITYPROVIDER1,new EntityProvider1()); // uniquely registered
        putPool(POOL_RETRIEVE_ENTITYPROVIDER2,new EntityProvider2()); // registered with specific keys
        putPool(POOL_RETRIEVE_ENTITYPROVIDER3,new EntityProvider3()); // uniquely registered or not, depending on multiplicity
    }
	
	
	
	
	private static class EntityProvider1 implements Retrieve, Transform
    {
        public Object retrieve(String key) throws Exception
        {
        	s0_loadEntity(key);
        	return uniqueEntity_(key,key);
        }
		public Object transform(Object obj) throws Exception
		{return retrieve((String)obj);}
    }
	
	
	
	
    
    private static class EntityProvider2 implements Retrieve, Register, Transform
    {
        private String entityName;
        
        public void register(String key, Object obj) throws Exception
        {
            if(key.equals("entityName")) {entityName = (String)obj;return;}
            throw new Exception("Unknown key: ["+key+"]");
            
        }
        public Object retrieve(String key) throws Exception
        {
        	if(entityName==null) throw new Exception("Attempt to use EntityProvider2 without previously registering entity name");
        	s0_loadEntity(entityName);
        	return uniqueEntity_(entityName,key);
        }
		public Object transform(Object obj) throws Exception
		{return retrieve((String)obj);}
    }
    
    
    
    
    
    
    
    private static class EntityProvider3 implements Retrieve, Transform
    {
        public Object retrieve(String key) throws Exception
        {
        	s0_loadEntity(key);
        	if(isMultiple(key)) return s0_generateEntity(key);
            return uniqueEntity_(key,key);
        }
        public Object transform(Object obj) throws Exception
		{return retrieve((String)obj);}
    }
    
    
    
    
    private static Object uniqueEntity_(String name, String key) throws Exception
    {
    	Map m = map_entityInstances();
        if(!m.containsKey(key))
        	m.put(key,s0_generateEntity(name));
        return m.get(key);
    }
}
