package gus05.manager.gus.kassia.layer3.c06.initentityclassloader_bin;

import gus05.framework.core.Entity;
import gus05.framework.features.Retrieve;

import java.io.File;
import java.net.URL;
import java.net.URLClassLoader;


public class EntityClassLoader_bin implements Retrieve {

	
	private File binDir;
	private File rootDir;
	private URLClassLoader loader;
	
	
	public EntityClassLoader_bin(File binDir) throws Exception
	{this.binDir = binDir;}
	
	
	
	private void initLoader() throws Exception
	{
		rootDir = new File(binDir,"gus05"+File.separator+"entity");
		if(!rootDir.exists() || !rootDir.isDirectory())
			throw new Exception("Dir ["+binDir+"] is not an entity bin directory");
		loader = new URLClassLoader(new URL[]{binDir.toURI().toURL()});
	}
	
	
	
	public Object retrieve(String key) throws Exception
	{
		initLoader();
		return loadEntityClass(key);
	}
	
	
	
	private Class loadEntityClass(String name) throws Exception
	{
		String path = name.replace(".",File.separator);
		File d = new File(rootDir,path);
		File[] f = d.listFiles();
		
		for(int i=0;i<f.length;i++)
	    {
	    	File file = f[i];
	    	String fileName = file.getName();
	        
	        if(fileName.endsWith(".class") && !fileName.contains("$"))
	        {
	            String classpath = formatClasspath(name,fileName);
	            Class c = loader.loadClass(classpath);
	            if(Entity.class.isAssignableFrom(c)) return c;
	        }
	    }
	    throw new Exception("Class for entity ["+name+"] could not be found inside bin: ["+binDir+"]");
	}
	


	private String formatClasspath(String entityName, String fileName)
	{
		int l = fileName.length();
		return "gus05.entity."+entityName+"."+fileName.substring(0,l-6);
	}
}
