package gus05.manager.gus.kassia.layer3.e02.initdatabuilder;


import java.io.File;
import java.io.InputStream;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

import javax.swing.tree.TreeModel;

import gus05.framework.features.Give;
import gus05.framework.features.Provide;
import gus05.manager.gus.kassia.layer3.KS6;
import gus05.manager.gus.kassia.layer3.tools.data.*;


public class E02 extends KS6 implements Give {

	
	
	public static void initDataBuilder() throws Exception
	{
        putPoolMap(POOL_MAP_DATASOURCE);
        putPool(POOL_GIVE_DATABUILDER,new E02());
	}
	
	
	
	public void give(Object obj) throws Exception
	{buildData_((String)obj);}
	
	
	
	
	private void buildData_(String id) throws Exception
    {
        if(!id.contains("#"))
        	throw new Exception("Invalid dataID: ["+id+"]");
        
        String[] n = id.split("#",2);
        String type = n[0];
        String sourceName = n[1];
        
        Object src = s1_findDataSource(sourceName);
        if(src!=null) registerSource(id,src);

    	Object data = buildData(id,type,src);
    	registerData(id,data);
    }
	
	
	
	private void persistData_(String id)
	{
		try{s0_persistData(id);}
    	catch(Exception e)
    	{err(E02.class,"persistData_(String)",e);}
	}
	
	
	
	
	
	
	
	private Object buildData(String id, String type, Object src) throws Exception
	{
		if(type.equals(PROVIDER_DATALIST)) return buildList(id,src);
    	if(type.equals(PROVIDER_DATASET)) return buildSet(id,src);
    	if(type.equals(PROVIDER_DATAMAP)) return buildMap(id,src);
    	if(type.equals(PROVIDER_DATATREE)) return buildTree(id,src);

    	if(type.equals(PROVIDER_DATALIST_SECURED)) return buildListSecured(id,src);
    	if(type.equals(PROVIDER_DATASET_SECURED)) return buildSetSecured(id,src);
    	if(type.equals(PROVIDER_DATAMAP_SECURED)) return buildMapSecured(id,src);
    	if(type.equals(PROVIDER_DATATREE_SECURED)) return buildTreeSecured(id,src);

    	throw new Exception("Unknown data type: ["+type+"]");
	}
	
	
	
	
	
	
	
	
	private void registerSource(String id, Object src)
	{map_dataSource().put(id,src);}
	
	
	private void registerData(String id, Object data)
	{map_dataObject().put(id,data);}
	
	

	
	
	
	
	
	private List buildList(String id, Object src) throws Exception
	{
		if(src==null)					return new List1_n(id,new ArrayList());
    	if(src instanceof URL)			return new List1_n(id,readListU((URL)src));
    	if(src instanceof File)			return new List1_p(id,readListU((File)src));
    	if(src instanceof InputStream)	return new List1_n(id,readListU((InputStream)src));
    	if(src instanceof String)		return new List1_n(id,readListU((String)src));
    	if(src instanceof List)			return new List1_n(id,(List)src);
    	if(src instanceof Provide)		return (List)((Provide)src).provide();
    	
    	throw new Exception("Invalid source for list: ["+src.getClass().getName()+"]");
	}
	
	
	
	
	private Set buildSet(String id, Object src) throws Exception
	{
		if(src==null)					return new Set1_n(id,new HashSet());
    	if(src instanceof URL)			return new Set1_n(id,readSetU((URL)src));
    	if(src instanceof File)			return new Set1_p(id,readSetU((File)src));
    	if(src instanceof InputStream)	return new Set1_n(id,readSetU((InputStream)src));
    	if(src instanceof String)		return new Set1_n(id,readSetU((String)src));
    	if(src instanceof Set)			return new Set1_n(id,(Set)src);
    	if(src instanceof Provide)		return (Set)((Provide)src).provide();
    	
    	throw new Exception("Invalid source for set: ["+src.getClass().getName()+"]");
	}
	
	
	
	private Map buildMap(String id, Object src) throws Exception
	{
		if(src==null)					return new Map1_n(id,new Properties());
    	if(src instanceof URL)			return new Map1_n(id,readMapU((URL)src));
    	if(src instanceof File)			return new Map1_p(id,readMapU((File)src));
    	if(src instanceof InputStream)	return new Map1_n(id,readMapU((InputStream)src));
    	if(src instanceof Map)			return new Map1_n(id,(Map)src);
    	if(src instanceof Provide)		return (Map)((Provide)src).provide();
    	
    	throw new Exception("Invalid source for map: ["+src.getClass().getName()+"]");
	}
	
	
	
	private TreeModel buildTree(String id, Object src) throws Exception
	{
		if(src==null)					return new Tree1_n(id,"");
    	if(src instanceof URL)			return new Tree1_n(id,readTextU((URL)src));
    	if(src instanceof File)			return new Tree1_p(id,readTextU((File)src));
    	if(src instanceof InputStream)	return new Tree1_n(id,readTextU((InputStream)src));
    	if(src instanceof String)		return new Tree1_n(id,readTextU((String)src));
    	if(src instanceof Provide)		return (TreeModel)((Provide)src).provide();
    	
    	throw new Exception("Invalid source for treeModel: ["+src.getClass().getName()+"]");
	}
	
	
	
	
	
	
	
	
	
	
	private Object buildListSecured(String id, Object src) throws Exception
	{
		if(src instanceof File)		return new List1_ps(id,readListU_C((File)src));
    	
    	throw new Exception("Invalid source for secured list: ["+src.getClass().getName()+"]");
	}
	
	private Object buildSetSecured(String id, Object src) throws Exception
	{
		if(src instanceof File)		return new Set1_ps(id,readSetU_C((File)src));
    	
    	throw new Exception("Invalid source for secured set: ["+src.getClass().getName()+"]");
	}
	
	private Object buildMapSecured(String id, Object src) throws Exception
	{
		if(src instanceof File)		return new Map1_ps(id,toProp(readMapU_C((File)src)));
    	
    	throw new Exception("Invalid source for secured map: ["+src.getClass().getName()+"]");
	}
	
	private Object buildTreeSecured(String id, Object src) throws Exception
	{
    	if(src instanceof File)		return new Tree1_ps(id,readTextU_C((File)src));
    	
    	throw new Exception("Invalid source for secured treeModel: ["+src.getClass().getName()+"]");
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	private class List1_n extends AbstractList
    {    
        public List1_n(String id, List list) {super(id,list);}
        
        protected void modified(String eventID)
        {send(this,eventID);}

        protected void save(Object obj) throws Exception {}
    }
    
    private class List1_p extends List1_n
    {    
        public List1_p(String id, List list) {super(id,list);}
        
        protected void modified(String eventID)
        {
        	persistData_(id);
        	send(this,eventID);
        }
        protected synchronized void save(Object obj) throws Exception
        {writeListU((File)obj,list);}
    }
    
    private class List1_ps extends List1_p
    {    
        public List1_ps(String id, List list) {super(id,list);}
        
        protected synchronized void save(Object obj) throws Exception
        {writeListU_C((File)obj,list);}
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    private class Set1_n extends AbstractSet
    {
    	public Set1_n(String id, Set set) {super(id,set);}
    	
        protected void modified(String eventID)
        {send(this,eventID);}
        
        protected void save(Object obj) throws Exception {}
    }
    
    private class Set1_p extends Set1_n
    {
    	public Set1_p(String id, Set set) {super(id,set);}
    	
        protected void modified(String eventID)
        {
        	persistData_(id);
        	send(this,eventID);
        }
        protected synchronized void save(Object obj) throws Exception
        {writeSetU((File) obj,set);}
    }
    
    private class Set1_ps extends Set1_p
    {
    	public Set1_ps(String id, Set set) {super(id,set);}
    	
        protected synchronized void save(Object obj) throws Exception
        {writeSetU_C((File) obj,set);}
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    private class Map1_n extends AbstractMap
    {
        public Map1_n(String id, Map map){super(id,map);}
        
        protected void modified(String eventID)
        {send(this,eventID);}
        
        protected void save(Object obj) throws Exception {}
    }
    
    private class Map1_p extends Map1_n
    {
        public Map1_p(String id, Map map){super(id,map);}
        
        protected void modified(String eventID)
        {
        	persistData_(id);
        	send(this,eventID);
        }
        protected synchronized void save(Object obj) throws Exception
        {writeMap((File)obj,map);}
    }
    
    private class Map1_ps extends Map1_p
    {
        public Map1_ps(String id, Map map){super(id,map);}
        
        protected synchronized void save(Object obj) throws Exception
        {writeMapU_C((File)obj,map);}
    }
    
    
    
    
    
    
    
    
    
    
    
    public class Tree1_n extends AbstractTree
    {
        public Tree1_n(String id, String value) throws Exception {super(id,value);}
        
        protected void modified(String eventID)
        {send(eventID);}
        
        protected void save(Object obj) throws Exception {}
    }
    
    public class Tree1_p extends Tree1_n
    {
    	public Tree1_p(String id, String value) throws Exception {super(id,value);}
    	
        protected void modified(String eventID)
        {
        	persistData_(id);
        	send(eventID);
        }
        protected void save(Object obj) throws Exception
        {writeTextU((File)obj,description());}
    }
    
    public class Tree1_ps extends Tree1_p
    {
    	public Tree1_ps(String id, String value) throws Exception {super(id,value);}
    	
        protected void save(Object obj) throws Exception
        {writeTextU_C((File)obj,description());}
    }
}
