package gus05.manager.gus.kassia.layer3.e03.initdatasourcefinder;



import java.io.File;
import java.net.URL;

import gus05.framework.features.Retrieve;
import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer3.KS6;


public class E03 extends KS6 implements Retrieve, Transform {

	
	
	public static void initDataSourceFinder() throws Exception
	{putPool(POOL_RETRIEVE_DATASOURCEFINDER,new E03());}
	
	
	
	public Object retrieve(String key) throws Exception
	{return findSource_(key);}
	
	
	public Object transform(Object obj) throws Exception
	{return findSource_((String) obj);}
	
	
	
	
	private Object findSource_(String name) throws Exception
	{
		String type = name.split("\\.")[0];
		String info = name.substring(type.length()+1);
		
		Transform t = (Transform) findElement(PROPSTART_DATASRC+type);
        if(t!=null) return t.transform(info);
		
    	if(type.equals("null"))		return null;
		if(type.equals("path"))		return findPath(name,info);
        if(type.equals("pool"))		return findPool(name,info);
        if(type.equals("url"))		return findUrl(name,info);
        if(type.equals("inside"))	return findInside(name,info);
        
        throw new Exception("Source not found for name ["+name+"] : undefined type: ["+type+"]");
	}

	
	
    
	
	private File findPath(String name, String info) throws Exception
    {
		File f = s0_getFile(name);
		s0_initFile(f);
		if(f==null || !f.exists()) throw new Exception("Source path not found for id: ["+name+"]");
    	return f;
    }
    
    private File findPool(String name, String info) throws Exception
    {
    	File f = s0_getFilePool(info);
		initFile1(f);
		if(f==null || !f.exists()) throw new Exception("Source pool not found for id: ["+name+"]");
    	return f;
    }
    
    private URL findUrl(String name, String info) throws Exception
    {
    	if(!hasProp(name))
    		throw new Exception("Source url not found for id: ["+name+"]");
    	return new URL(getProp(name));
    }
    
    private Object findInside(String name, String info) throws Exception
    {
    	return inside.retrieve(info);
    }
    
}
