package gus05.manager.gus.kassia.layer3.e05.initdatabackup;



import java.io.File;
import java.util.HashSet;
import java.util.Map;

import gus05.framework.features.Give;
import gus05.manager.gus.kassia.layer3.KS6;



public class E05 extends KS6 implements Give {

	
	
	public static void initDataBackup() throws Exception
	{putPool(POOL_GIVE_DATABACKUP,new E05());}

	
	
	
	
	
	public void give(Object obj) throws Exception
	{
		String id = (String) obj;
		
		String sourceName = id.split("#",2)[1];
		if(!rule().contains(";"+sourceName+";")) return;
		if(!firstTime(sourceName)) return;
		
		Map m = map_dataSource();
		if(!m.containsKey(id))
			throw new Exception("Unknown data id for backup: "+id);
		
		Object src = m.get(id);
		backupSource(src);
	}
	
	
	
	
	private HashSet set = new HashSet();
	
	private boolean firstTime(String id)
	{return set.add(id);}
	
	
	private String rule()
	{
		String p = getProp(PROPKEY_APPBACKUPLIST,"");
		return ";"+p+";";
	}
	
	
	
	
	
	private void backupSource(Object src) throws Exception
	{
		if(src instanceof File)
			backupFile((File)src);
		else throw new Exception("Invalid source type for backup: ["+src.getClass().getName()+"]");
	}
	
	
	
	
	private void backupFile(File file) throws Exception
	{
		if(backupDir==null) initBackupDir();
		if(backupDir==null || !backupDir.exists()) return;

		File backupFile = new File(backupDir,now()+"_"+file.getName());
		copy(file,backupFile);
		printM(this,"backupFile(File)","Backuped file: ["+file+"]");
	}
	
	
	
	private File backupDir;
	private boolean initialized = false;
	
	private void initBackupDir() throws Exception
	{
		if(initialized) return;
		initialized = true;
		
		backupDir = s0_getFile(FILEID_BACKUPDIR);
		if(backupDir==null) throw new Exception("fileID "+FILEID_BACKUPDIR+" not found");
		if(!backupDir.exists()) s0_initDir(backupDir);
		if(!backupDir.exists()) throw new Exception("backupDir does not exist: ["+backupDir+"]");
	}
}
