package gus05.manager.gus.kassia.layer3.f01.initlingsupport;


import java.util.Map;

import gus05.framework.features.Give;
import gus05.framework.features.Provide;
import gus05.framework.resources.StringProvider;
import gus05.framework.tools.DefaultSupport;
import gus05.manager.gus.kassia.layer3.KS6;



public class F01 extends KS6 {

	
	
	public static void initLingSupport() throws Exception
	{
		putPool(POOL_SUPPORT_LING,new AppLingSupport());
		putPool(POOL_STRINGPROVIDER_LING,new AppLingString());
	}

	
	
	private static class AppLingSupport extends DefaultSupport implements Give, Provide
	{
	    public void give(Object obj) throws Exception
	    {
	        String lang = (String)obj;
	        if(lang.equals(language()))return;
	        
	        setLanguage(lang);
	        languageChanged();
	    }
	    
	    public Object provide() throws Exception
	    {return language();}
	    
	    private void languageChanged()
	    {send(this,"languageChanged()");}
	}
	
	
	
	
	
	
	private static class AppLingString implements StringProvider
	{
	    public String getString(String key)
	    {
	        handleKey(key);
	        
	        String lingKey = key+"_"+language();
	        if(map_lings().containsKey(lingKey))
	        {
	            String lingValue = (String) map_lings().get(lingKey);
	            if(!lingValue.equals("")) return lingValue;
	        }
	        return key;
	    }
	}
	
	
	
	private static void handleKey(String key)
    {
		try
		{
			Give g = (Give) findElement(POOL_GIVE_HANDLELINGKEY);
			if(g!=null) g.give(key);
		}
		catch(Exception e)
		{err(F01.class,"handleKey(String)",e);}
    }
	
	
	
	
	
	
	
	
	
	
	
	
	
	private static String language;
	
	private static void setLanguage(String newLanguage) throws Exception
	{
		checkLanguageCode(newLanguage);
    	language = newLanguage;
    	
    	Map map = getLanguagePersMap();
		if(map!=null) map.put(LANGUAGEKEY,language);
	}
	
	
	
	private static void checkLanguageCode(String code) throws Exception
    {
    	if(!isISO639_LanguageCode(code))
    		throw new Exception("Language code ["+code+"] is not ISO639");
    	if(!isSupportedLanguageCode(code))
    		throw new Exception("Language code ["+code+"] is not supported");
    }
	
	
	
	
	
	private static String language()
	{
		if(language==null)
			language = initialLanguage();
		return language;
	}
	
	
	
	
	
    
	private static String initialLanguage()
    {
		if(hasProp(PROPKEY_LANGUAGEPERSMAP))
		{
			Map map = getLanguagePersMap();
			if(map!=null && map.containsKey(LANGUAGEKEY))
			{
				String lang = (String) map.get(LANGUAGEKEY);
				if(isValidLanguageCode(lang)) return lang;
			}
		}
		
    	if(hasProp(PROPKEY_APPLANGUAGEINITIAL))
    	{
    		String seq = getProp(PROPKEY_APPLANGUAGEINITIAL);
        	String[] n = seq.split(";");
        	
        	for(int i=0;i<n.length;i++)
        	{
        		String lang = n[i].equals("<user>")?SYS_USERLANGUAGE:n[i];
        		if(isValidLanguageCode(lang)) return lang;
        	}
    	}
    	
    	if(hasProp(PROPKEY_APPLANGUAGESUPPORTED))
    	{
    		if(isValidLanguageCode(SYS_USERLANGUAGE)) return SYS_USERLANGUAGE;
    		
    		String seq = getProp(PROPKEY_APPLANGUAGESUPPORTED);
        	String[] n = seq.split(";");
        	
        	for(int i=0;i<n.length;i++)
        	{
        		String lang = n[i];
        		if(isValidLanguageCode(lang)) return lang;
        	}
    	}
    	
    	return SYS_USERLANGUAGE;
    }
	
	
	
	
	
	
	
	private static boolean isValidLanguageCode(String code)
	{
		return isISO639_LanguageCode(code) && isSupportedLanguageCode(code);
	}
	
	
	private static boolean isSupportedLanguageCode(String code)
    {
    	if(!hasProp(PROPKEY_APPLANGUAGESUPPORTED)) return true;
    	String supported = getProp(PROPKEY_APPLANGUAGESUPPORTED);
    	return supported.contains(code);
    }
	
	
	
	private static Map getLanguagePersMap()
	{
		try
		{
			String dataID = getProp(PROPKEY_LANGUAGEPERSMAP,null);
			return dataID!=null?s1_getDataMap(dataID):null;
		}
		catch(Exception e)
		{err(F01.class,"getLanguagePersMap()",e);}
		return null;
	}
}
