package gus05.manager.gus.kassia.layer3.g05.initresourceprovider.file1;


import java.io.File;

import gus05.framework.core.Entity;
import gus05.manager.gus.kassia.layer3.KS6;
import gus05.manager.gus.kassia.layer3.tools.AbstractResourceProvider;


public class G05 extends KS6 {

	
	
	public static void initResourceProvider_file1()
	{
		map_providers().put(PROVIDER_FILESTRING,new RP_fileString());
		map_providers().put(PROVIDER_FILESTRINGARRAY,new RP_fileStringArray());
		map_providers().put(PROVIDER_FILEPROPERTIES,new RP_fileProperties());
		map_providers().put(PROVIDER_FILEURL,new RP_fileUrl());
	}



	
	
	
	private static class RP_fileString extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
	        File file = findFile(entity,id,key);
	        return text(file);
	    }
	}
	
	
	private static class RP_fileStringArray extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
	        File file = findFile(entity,id,key);
	        return text(file).split("\n",-1);
	    }
	}
	
	
	private static class RP_fileProperties extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
	        File file = findFile(entity,id,key);
	        return prop(file);
	    }
	}
	
	
	private static class RP_fileUrl extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
	        File file = findFile(entity,id,key);
	        return file.toURI().toURL();
	    }
	}
	
    
    
    
    
    private static File findFile(Entity entity, String id, String key) throws Exception
    {
    	File file = key.equals("pool")?getFile_pool(entity,id):s0_getFile(key);
    	if(file==null) throw new Exception("Unknown fileID: ["+key+"]");

        if(!file.exists()) s0_initFile(file);
        if(!file.exists()) throw new Exception("FileID ["+key+"] is not an existing path: ["+file+"]");
        if(!file.isFile()) throw new Exception("FileID ["+key+"] is not a file path: ["+file+"]");
        return file;
    }
}
