package gus05.manager.gus.kassia.layer3.g12.initresourceprovider.process;


import java.util.Map;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Graphic;
import gus05.framework.features.Provide;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer3.KS6;
import gus05.manager.gus.kassia.layer3.tools.AbstractResourceProvider;


public class G12 extends KS6 {

	
	
	public static void initResourceProvider_process()
	{
        Map m = map_providers();
        
        m.put(PROVIDER_PROCESSGUI,new RP_processGui());
        m.put(PROVIDER_PROCESSPROVIDE,new RP_processProvide());
        m.put(PROVIDER_PROCESSRETRIEVE,new RP_processRetrieve());
        m.put(PROVIDER_PROCESSTRANSFORM,new RP_processTransform());
	}
	
	
	
	
	
	private static class RP_processProvide extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
			Object obj = Outside.resource(entity,key);
			if(!(obj instanceof Provide)) throw new Exception("Provide feature expected for rule: ["+key+"]");
    		return ((Provide)obj).provide();
		}
    }

    private static class RP_processGui extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
    		Object obj = Outside.resource(entity,key);
    		if(!(obj instanceof Graphic)) throw new Exception("Graphic feature expected for rule: ["+key+"]");
    		return ((Graphic)obj).gui();
		}
    }
    
    private static class RP_processRetrieve extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
    		String[] n = key.split(" ",2);
    		if(n.length!=2) throw new Exception("Invalid key for RP_processRetrieve: ["+key+"]");
    		
    		Object obj = Outside.resource(entity,n[0]);
    		if(!(obj instanceof Retrieve)) throw new Exception("Retrieve feature expected for rule: ["+key+"]");
    		return ((Retrieve)obj).retrieve(n[1]);
		}
    }
    
    private static class RP_processTransform extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
    		String[] n = key.split(" ",2);
    		if(n.length!=2) throw new Exception("Invalid key for RP_processTransform: ["+key+"]");
    		
    		Object obj = Outside.resource(entity,n[0]);
    		Object input = Outside.resource(entity,n[1]);
    		
    		if(!(obj instanceof Transform)) throw new Exception("Transform feature expected for rule: ["+key+"]");
    		return ((Transform)obj).transform(input);
		}
    }
}
