package gus05.manager.gus.kassia.layer3.g13.initresourceprovider.wrap;


import java.util.Collection;
import java.util.Map;

import javax.swing.JComponent;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Execute;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Provide;
import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer3.KS6;
import gus05.manager.gus.kassia.layer3.tools.AbstractResourceProvider;


public class G13 extends KS6 {

	
	
	public static void initResourceProvider_wrap()
	{
        Map m = map_providers();
        
        m.put(PROVIDER_WRAP_EXECUTE,new RP_wrapExecute());
        m.put(PROVIDER_WRAP_FILTER,new RP_wrapFilter());
        m.put(PROVIDER_WRAP_TRANSFORM,new RP_wrapTransform());
        m.put(PROVIDER_WRAP_GUI,new RP_wrapGui());
        m.put(PROVIDER_WRAP_PROVIDE,new RP_wrapProvide());
	}
	
	
	
	
	/*
     * EXECUTE WRAPPER
     */
    private static class RP_wrapExecute extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
    		String[] n = key.split(" ",2);
    	    
    	    Give give = (Give) Outside.resource(entity,n[0]);
    	    Object input = Outside.resource(entity,n[1]);
    	    return new ExecuteWrapper(give,input);
		}
    }

    private static class ExecuteWrapper implements Execute
    {
    	private Give give;
    	private Object input;

    	public ExecuteWrapper(Give give, Object input)
    	{
    		this.give = give;
    		this.input = input;
    	}
    	public void execute() throws Exception
    	{give.give(input);}
    }

    
    
    
    
    /*
     * FILTER WRAPPER
     */
    private static class RP_wrapFilter extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
			Object obj = Outside.resource(entity,key);
	        if(obj instanceof Collection) return filterCol((Collection) obj);
	        if(obj instanceof Map) return filterMap((Map) obj);
	        
	        throw new Exception("Invalid info: ["+key+"]");
		}
    }
    
    
    
    
    
    
    
    /*
     * TRANSFORM WRAPPER
     */
    private static class RP_wrapTransform extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
			String[] n = key.split(" ",2);
    	    Give give = (Give) Outside.resource(entity,n[0]);
    	    Provide provide = (Provide) Outside.resource(entity,n[1]);
    		return new TransformWrapper(give,provide);
		}
    }
    
    private static class TransformWrapper implements Transform
    {
        private Give give;
        private Provide provide;
        
        public TransformWrapper(Give give, Provide provide)
        {
        	this.give = give;
        	this.provide = provide;
        }
        public Object transform(Object obj) throws Exception
        {
        	give.give(obj);
        	return provide.provide();
        }
    }
    
    
    
    
    
    
    /*
     * GUI WRAPPER
     */
    private static class RP_wrapGui extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
			JComponent comp = (JComponent) Outside.resource(entity,key);
    		return new GraphicWrapper(comp);
		}
    }
    
    private static class GraphicWrapper implements Graphic
    {
        private JComponent comp;
        public GraphicWrapper(JComponent comp)
        {this.comp = comp;}

        public JComponent gui()
        {return comp;}
    }
    
    
    
    
    
    /*
     * PROVIDE WRAPPER
     */
    private static class RP_wrapProvide extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
    		Object obj = Outside.resource(entity,key);
    		return new ProvideWrapper(obj);
		}
    }
    
    private static class ProvideWrapper implements Provide
    {
        private Object obj;
        public ProvideWrapper(Object obj)
        {this.obj = obj;}

        public Object provide() throws Exception
        {return obj;}
    }
}
