package gus05.manager.gus.kassia.layer3.g14.initresourceprovider.combine;


import java.util.Map;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Execute;
import gus05.framework.features.Filter;
import gus05.framework.features.Give;
import gus05.framework.features.Register;
import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer3.KS6;
import gus05.manager.gus.kassia.layer3.tools.AbstractResourceProvider;


public class G14 extends KS6 {

	
	
	public static void initResourceProvider_combine()
	{
        Map m = map_providers();
        
        m.put(PROVIDER_COMBINE_EXECUTE,new RP_combineExecute());
        m.put(PROVIDER_COMBINE_GIVE,new RP_combineGive());
        m.put(PROVIDER_COMBINE_REGISTER,new RP_combineRegister());
        m.put(PROVIDER_COMBINE_TRANSFORM,new RP_combineTransform());
        m.put(PROVIDER_COMBINE_FILTER_AND,new RP_combineFilterAnd());
        m.put(PROVIDER_COMBINE_FILTER_OR,new RP_combineFilterOr());
	}
	
	
	
	
	
	private static class RP_combineExecute extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
    		String[] n = key.split(" ");
            
            Execute[] e = new Execute[n.length];
            for(int i=0;i<e.length;i++)
            e[i] = (Execute) Outside.resource(entity,n[i]);
            return new CombineExecute(e);
		}
    }
	
	private static class CombineExecute implements Execute
    {
        private Execute[] e;
        public CombineExecute(Execute[] e)
        {this.e = e;}

        public void execute() throws Exception
        {for(int i=0;i<e.length;i++) e[i].execute();}
    }
	
	
	
	
	
	
	
	
	
	private static class RP_combineGive extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
    		String[] n = key.split(" ");
            
            Give[] g = new Give[n.length];
            for(int i=0;i<g.length;i++)
            g[i] = (Give) Outside.resource(entity,n[i]);
            return new CombineGive(g);
		}
    }
	
	private static class CombineGive implements Give
    {
        private Give[] g;
        public CombineGive(Give[] g)
        {this.g = g;}
        
        public void give(Object obj) throws Exception
        {for(int i=0;i<g.length;i++) g[i].give(obj);}
    }
	
	
	
	
	
	
	
	
	
	
	private static class RP_combineRegister extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
    		String[] n = key.split(" ");
            
            Register[] r = new Register[n.length];
            for(int i=0;i<r.length;i++)
            r[i] = (Register) Outside.resource(entity,n[i]);
            return new CombineRegister(r);
		}
    }
	
	private static class CombineRegister implements Register
    {
        private Register[] r;
        public CombineRegister(Register[] g)
        {this.r = g;}
        
        public void register(String key, Object obj) throws Exception
        {for(int i=0;i<r.length;i++) r[i].register(key,obj);}
    }
	
	
	
	
	
	
	
	

    
    
    private static class RP_combineTransform extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
    		String[] n = key.split(" ");
            
    		Transform[] t = new Transform[n.length];
            for(int i=0;i<t.length;i++)
            t[i] = (Transform) Outside.resource(entity,n[i]);
            return new CombineTransform(t);
		}
    }
    
    private static class CombineTransform implements Transform
    {
        private Transform[] t;
        public CombineTransform(Transform[] t)
        {this.t = t;}
        
        public Object transform(Object obj) throws Exception
        {
            for(int i=0;i<t.length;i++) obj = t[i].transform(obj);
            return obj;
        }
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    private static class RP_combineFilterAnd extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
    		String[] n = key.split(" ");
            
    		Filter[] f = new Filter[n.length];
            for(int i=0;i<f.length;i++)
            f[i] = (Filter) Outside.resource(entity,n[i]);
            return new CombineFilterAnd(f);
		}
    }
    
    private static class CombineFilterAnd implements Filter
    {
        private Filter[] f;
        public CombineFilterAnd(Filter[] f)
        {this.f = f;}
        
        public boolean filter(Object obj) throws Exception
        {
            for(int i=0;i<f.length;i++)
            	if(!f[i].filter(obj)) return false;
            return true;
        }
    }

    
    
    
    
    
    
    
    
    
    
    
    
    
    private static class RP_combineFilterOr extends AbstractResourceProvider
	{
		public Object retrieveResource(Entity entity, String id, String key) throws Exception
	    {
    		String[] n = key.split(" ");
            
    		Filter[] f = new Filter[n.length];
            for(int i=0;i<f.length;i++)
            f[i] = (Filter) Outside.resource(entity,n[i]);
            return new CombineFilterOr(f);
		}
    }
    
    private static class CombineFilterOr implements Filter
    {
        private Filter[] f;
        public CombineFilterOr(Filter[] f)
        {this.f = f;}
        
        public boolean filter(Object obj) throws Exception
        {
            for(int i=0;i<f.length;i++)
            	if(f[i].filter(obj)) return true;
            return false;
        }
    }
}
