package gus05.manager.gus.kassia.layer3.h03.initlogfile;

import java.io.File;
import java.io.PrintStream;

import gus05.framework.features.Give;
import gus05.manager.gus.kassia.layer3.KS6;

public class H03 extends KS6 {

	
	public static void initLogFile()
    {
    	try
    	{
    		File logFile = findLogFile();
            if(logFile==null) return;

            if(!logFile.exists()) logFile.createNewFile();
            
            PrintStream log = new PrintStream(logFile,"UTF-8");
            Give g = (Give) p_log();
            g.give(log);
            
            putFile(FILEID_LOGFILE,logFile);
            printM(H03.class,"initLogFile()","Log file initialized: ["+logFile+"]");
    	}
    	catch(Exception e)
    	{err(H03.class,"initLogFile()",e);}
    }
	
	
	
    
    private static File findLogFile() throws Exception
    {
        File logFile = s0_getFile(FILEID_LOGFILE);
        if(logFile!=null)
        {
            File parent = logFile.getParentFile();
            s0_initDir(parent);
            return logFile;
        }
        
        File logDir = s0_getFile(FILEID_LOGDIR);
        if(logDir==null) return null;
        
        s0_initDir(logDir);
        if(!logDir.canWrite()) throw new Exception("Cannot write inside log dir: ["+logDir+"]");
        
        String appName = getProp_u(PROPKEY_APPNAME);
        String fileName = appName+"_"+now()+".log";
        return new File(logDir,fileName);
    }
}
