package gus05.manager.gus.kassia.layer3.tools;

import gus05.framework.features.Transform;

import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

public class Tool_storeArray {

	/*
	 * La transformation passe en paramtre pour l'impression du set et du list doit permettre de rendre
	 * chaque lment uniligne (suppression des retours  la ligne) par un encodage spcifique.
	 * 
	 * La transformation passe en paramtre pour la restitution du set et du list  partir du texte source
	 * doit appliquer l'encodage inverse pour restituer la valeur chaque lement (valeur texte potentiellement
	 * multiligne) 
	 */
	
    private static String[] toArray(String text)
    {
    	text = text.replace("\r","");
    	if(text.equals("")) return new String[0];
    	if(text.endsWith("\n")) text = text.substring(0,text.length()-1);
    	return text.split("\n",-1);
    }
    
    private static List list(String[] array, Transform t) throws Exception
    {
    	ArrayList list = new ArrayList();
        for(int i=0;i<array.length;i++)
        list.add(t.transform(array[i]));
        return list;
    }
    
    private static Set set(String[] array, Transform t) throws Exception
    {
    	HashSet set = new HashSet();
        for(int i=0;i<array.length;i++)
        set.add(t.transform(array[i]));
        return set;
    }
    
    private static String uniline(Object obj) throws Exception
    {
    	String s = (String) obj;
    	if(s.contains("\n")) throw new Exception("Multiline text detected: "+s);
    	if(s.contains("\r")) throw new Exception("Multiline text detected: "+s);
    	return s;
    }
    
    
    
    
    
    
    
    public static List list(String text, Transform t) throws Exception
    {return list(toArray(text),t);}
    
    public static Set set(String text, Transform t) throws Exception
    {return set(toArray(text),t);}
    
    
    
    public static void printSet(PrintStream out, Transform t, Set set) throws Exception
    {
    	Iterator it = set.iterator();
    	while(it.hasNext())
    	{
    		Object value = t.transform(it.next());
    		out.println(uniline(value));
    	}
    	out.close();
    }

    public static void printList(PrintStream out, Transform t, List list) throws Exception
    {
    	for(int i=0;i<list.size();i++)
    	{
    		Object value = t.transform(list.get(i));
    		out.println(uniline(value));
    	}
    	out.close();
    }
}
