package gus05.manager.gus.kassia.layer3.tools.data;

import gus05.framework.features.Filter;
import gus05.framework.features.Provide;
import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Transform;
import gus05.framework.tools.DefaultSupport;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;



public abstract class AbstractList extends DefaultSupport implements List, Retrieve, Register, Transform, Provide, Filter
{    
    protected List list;
    protected String id;
    
    public String toString() {return id;}
    
    protected String valueName = null;
    protected Class valueClass = null;
    
    protected Object lastElement;
    protected Object lastResult;
    protected int lastIndex;
    
    protected AbstractList(String id, List list)
    {
    	this.id = id;
    	this.list = list;
    }
    
    protected abstract void modified(String eventID);
    protected abstract void save(Object obj) throws Exception;
    
    
    public int size()                               {return list.size();}
    public boolean isEmpty()                        {return list.isEmpty();}
    public int indexOf(Object value)                {return list.indexOf(value);}
    public int lastIndexOf(Object value)            {return list.lastIndexOf(value);}
    public ListIterator listIterator()              {return list.listIterator();}
    public ListIterator listIterator(int index)     {return list.listIterator(index);}
    public List subList(int index1, int index2)     {return list.subList(index1,index2);}
    public Iterator iterator()                      {return list.iterator();}
    public Object[] toArray()                       {return list.toArray();}
    public Object[] toArray(Object[] array)         {return list.toArray(array);}
    public boolean contains(Object value)           {return list.contains(value);}
    public boolean containsAll(Collection c)        {return list.containsAll(c);}
    public Object get(int index)                    {return list.get(index);}
    public boolean equals(Object o)                 {return list.equals(o);}
    
    
    public void clear()
    {
        list.clear();
        modified("clear()");
    }
    
    public boolean add(Object value)
    {
        lastElement = value;
        boolean result = list.add(value);
        if(result) modified("add(Object)");
        return result;
    }
    
    public void add(int index, Object value)
    {
        lastIndex = index;
        lastElement = value;
        list.add(index,value);
        modified("add(int,Object)");
    }
    
    public boolean remove(Object value)
    {
        lastElement = value;
        boolean result = list.remove(value);
        if(result) modified("remove(Object)");
        return result;
    }
    
    public Object remove(int index)
    {
        lastIndex = index;
        lastResult = list.remove(index);
        modified("remove(int)");
        return lastResult;
    }
    
    public boolean addAll(Collection c)
    {
        boolean result = list.addAll(c);
        if(result) modified("addAll(Collection)");
        return result;
    }

    public boolean addAll(int index, Collection c)
    {
        lastIndex = index;
        boolean result = list.addAll(index,c);
        if(result) modified("addAll(int,Collection)");
        return result;
    }
    
    public boolean removeAll(Collection c)
    {
        boolean result = list.removeAll(c);
        if(result) modified("removeAll(Collection)");
        return result;
    }

    public boolean retainAll(Collection c)
    {
        boolean result = list.retainAll(c);
        if(result) modified("retainAll(Collection)");
        return result;
    }
    
    public Object set(int index, Object value)
    {
        lastIndex = index;
        lastElement = value;
        lastResult = list.set(index,value);
        modified("set(index,Object)");
        return lastResult;
    }
    


    
    public Object retrieve(String key) throws Exception
    {
        if(key.equals("lastElement"))return lastElement;
        if(key.equals("lastResult"))return lastResult;
        if(key.equals("lastIndex"))return new Integer(lastIndex);
        if(key.equals("list"))return list;
        
        if(key.equals("valueName"))return valueName;
        if(key.equals("valueClass"))return valueClass;
        
        if(key.equals("keys"))
            return new String[]{"lastElement","lastResult","lastIndex","list","valueName","valueClass"};
        
        throw new Exception("unknown key "+key);
    }


    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("valueName"))     {valueName = (String)obj;return;}
        if(key.equals("valueClass"))    {valueClass = (Class)obj;return;}
        if(key.equals("save")) 			{save(obj);return;}
        
        throw new Exception("unknown key "+key);
    }

    
    public boolean filter(Object obj) throws Exception      {return list.contains(obj);}
    public Object transform(Object obj) throws Exception    {return list.get(((Integer)obj).intValue());}
    public Object provide() throws Exception                {return list;}
}
