package gus05.manager.gus.kassia.layer3.tools.data;

import gus05.framework.features.Filter;
import gus05.framework.features.Provide;
import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;
import gus05.framework.tools.DefaultSupport;

import java.util.Collection;
import java.util.Iterator;
import java.util.Set;



public abstract class AbstractSet extends DefaultSupport implements Set, Retrieve, Register, Provide, Filter
{
	protected Set set;
	protected String id;
    public String toString() {return id;}
    
    
	private String valueName = null;
	private Class valueClass = null;
	
	private Object lastElement;
    
	
	protected abstract void modified(String eventID);
	protected abstract void save(Object obj) throws Exception;
	
	
	protected AbstractSet(String id,  Set set)
    {
		this.id = id;
		this.set = set;
	}

	
    public int size()                           {return set.size();}
    public boolean isEmpty()                    {return set.isEmpty();}
    public boolean contains(Object value)       {return set.contains(value);}
    public boolean containsAll(Collection c)    {return set.containsAll(c);}
    public Iterator iterator()                  {return set.iterator();}
    public Object[] toArray()                   {return set.toArray();}
    public Object[] toArray(Object[] array)     {return set.toArray(array);}
    public boolean equals(Object o)             {return set.equals(o);}
    
    public boolean add(Object value)
    {
        lastElement = value;
        boolean result = set.add(value);
        if(result) modified("add(Object)");
        return result;
    }

    public boolean remove(Object value)
    {
        lastElement = value;
        boolean result = set.remove(value);
        if(result)modified("remove(Object)");
        return result;
    }
    
    public boolean addAll(Collection c)
    {
        boolean result = set.addAll(c);    
        if(result)modified("addAll(Collection)");
        return result;
    }

    public boolean retainAll(Collection c)
    {
        boolean result = set.retainAll(c);    
        if(result)modified("retainAll(Collection)");
        return result;
    }
    
    public boolean removeAll(Collection c)
    {
        boolean result = set.removeAll(c);
        if(result) modified("removeAll(Collection)");
        return result;
    }
    
    public void clear()
    {
        set.clear();
        modified("clear()");
    }
    
    
    
    
    public Object retrieve(String key) throws Exception
    {
        if(key.equals("lastElement"))return lastElement;
        if(key.equals("set"))return set;

        if(key.equals("valueName"))return valueName;
        if(key.equals("valueClass"))return valueClass;
        
        if(key.equals("keys"))
            return new String[]{"lastElement","set","valueName","valueClass"};
        
        throw new Exception("unknown key "+key);
    }
    
    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("valueName"))     {valueName = (String)obj;return;}
        if(key.equals("valueClass"))    {valueClass = (Class)obj;return;}
        if(key.equals("save")) 			{save(obj);return;}
        
        throw new Exception("unknown key "+key);
    }
            
    public boolean filter(Object obj) throws Exception      {return set.contains(obj);}
    public Object provide() throws Exception                {return set;}
}
