package gus05.manager.gus.kassia.layer3.tools.icon;

import gus05.framework.features.Retrieve;

import java.awt.Component;
import java.awt.Graphics;

import javax.swing.Icon;

public abstract class AbstractLazyIcon implements Icon, Retrieve {
	
	private Icon icon;
	private String iconKey;
	
	public AbstractLazyIcon(String iconKey)
	{this.iconKey = iconKey;}
	
	protected abstract Icon build();
	protected String key(){return iconKey;}
	
	private void init()
	{if(icon==null) icon = build();}
	
	public int getIconHeight()
	{init();return icon.getIconHeight();}
     
	public int getIconWidth()
	{init();return icon.getIconWidth();}

	public void paintIcon(Component c, Graphics g, int x, int y)
	{init();icon.paintIcon(c,g,x,y);}

 	public String toString()
 	{init();return icon.toString();}
 	
 	
 	public Object retrieve(String key) throws Exception
 	{
 		if(key.equals("iconKey")) return iconKey;
 		if(key.equals("keys")) return new String[]{"iconKey"};
 		throw new Exception("Unknown key: "+key);
 	}
}
