package gus05.manager.gus.kassia.layer3.tools.printstream;

import gus05.manager.gus.kassia.layer3.KS6;
import java.io.PrintStream;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


public class PrintStream_Out extends PrintStream_Basic {

    
    private PrintStream p_app; 
    
    private long time1 = -1;
    private long time2 = -1;
    private Tracer tracer;
    
    
    public PrintStream_Out(PrintStream p_app)
    {
        super();
        this.p_app = p_app;
    }
    
    
    public void print(String m)
    {
    	p_app.print(m);
    	super.print(m);
    }
    
    
    public void println(String m)
    {
    	time1 = time2;
    	time2 = System.currentTimeMillis();
    	m = format(m);
    	
    	p_app.println("!"+m);
    	super.println(m);
    }
    
    
    
    
    
    private Pattern p_call = Pattern.compile("\\[\\^(-?[0-9]+)\\]");
    private Pattern p_trace = Pattern.compile("\\[t([1-9][0-9]*)\\]");
    
    
    private String format(String s)
    {
    	String a = start();
    	if(a.equals("-")) return s;
    	
    	s = a+s;
    	if(s.startsWith("[@]")) return "["+KS6.now_SS()+"]"+s.substring(3);
    	if(s.startsWith("[$]")) return "["+(time2-time1)+"ms]"+s.substring(3);
    	if(s.startsWith("[*]")) return "["+thread()+"]"+s.substring(3);
    	if(s.startsWith("[&]")) return "["+Thread.activeCount()+"]"+s.substring(3);
    	if(s.startsWith("[^]")) return "["+call(0)+"]"+s.substring(3);
    	
    	
    	Matcher m = p_call.matcher(s);
    	if(m.find())
    	{
    		int n = Integer.parseInt(m.group(1));
    		return "["+call(n)+"]";
    	}
    	
    	m = p_trace.matcher(s);
    	if(m.find())
    	{
    		int n = Integer.parseInt(m.group(1));
    		return "["+trace(n)+"]";
    	}
    	
    	return s;
    }
    
    
    
    private String start()
    {return KS6.getProp(KS6.PROPKEY_OUTPRINTLNSTART,"");}
    
    
    
    private String thread()
    {
    	Thread t = Thread.currentThread();
    	return t.getName()+" ("+t.getId()+")";
    }
    
    
    
    private String call(int level)
    {
    	Thread t = Thread.currentThread();
    	StackTraceElement[] ste_ = (StackTraceElement[]) Thread.getAllStackTraces().get(t);
    	if(level<-5 || level>ste_.length-5) return "Invalid call level: "+level;
    	StackTraceElement ste = ste_[5+level];
    	return level+"-"+KS6.location(ste);
    }
    
    
    
    private String trace(int length)
    {
    	if(tracer!=null && tracer.isAlive())
    		return "tracer is already running";
    	tracer = new Tracer(length);
    	tracer.start();
    	return "tracer started with length="+length+" for thread="+thread();
    }
}
