package gus05.manager.gus.kassia.layer3.tools.printstream;

public class Tracer extends Thread {

	
	private Thread t;
	private int length;
	private String root;
	
	private int current = 0;
	private String currentLocation = "";
	private StringBuilder b;
	
	
	
	public Tracer(int length)
	{
		super("KASSIA_TRACER_THREAD");
		this.length = length;
		t = Thread.currentThread();
		root = location(ste_()[7]);
		
		b = new StringBuilder("ROOT: "+root+"\n");
		setPriority(MAX_PRIORITY);
	}
	
	
	public void run()
	{
		while(current<length)
		{	
			if(!t.isAlive()) break;
			
			StackTraceElement[] ste_ = ste_();
			int ste_index = find(ste_);
			if(ste_index==-1) break;
			
			int ste_length = ste_.length;
			
			StackTraceElement ste = ste_[ste_index];
			String location = location(ste);
			
			if(location!=null && !location.equals(currentLocation))
			{
				currentLocation = location;
				current++;
				
				b.append(current+":{"+ste_index+"/"+ste_length+"} "+currentLocation+"\n");
			}
		}
		
		b.append("TRACER OVER\n");
		System.out.print(b.toString());
	}
	
	
	
	private StackTraceElement[] ste_()
	{
		return t.getStackTrace();
		//return (StackTraceElement[]) Thread.getAllStackTraces().get(t);
	}
	
	
	
	
	
	private int find(StackTraceElement[] ste_)
	{
		if(ste_==null) return -1;
		for(int i=0;i<ste_.length;i++)
		{
			String location = location(ste_[i]);
			if(location!=null && location.equals(root)) return i+1;
		}
		return -1;
	}
	
	
	private String location(StackTraceElement ste)
	{
		if(ste==null) return null;
		return ste.getClassName()+"@"+ste.getMethodName();
	}
	
	
}
