package gus05.manager.gus.kassia.layer3.v01.customizepool;

import java.io.File;
import java.util.Iterator;
import java.util.Properties;

import gus05.framework.core.Entity;
import gus05.manager.gus.kassia.layer3.tools.AbstractResourceLoader;


public class V01 extends AbstractResourceLoader {

	
	public static void customizePool() throws Exception
	{
		new V01().load("customizepool", PROPKEY_SEQUENCE_CUSTOMIZEPOOL, RESOURCEPATH_CUSTOMIZEPOOL);
	}
	
	
	protected void load_fromInside_(int index, String resourceID) throws Exception
	{
		Properties p = insideProp(resourceID);
		if(p!=null && !p.isEmpty()) handleProp(p);
	}


	protected void load_fromPathID_(int index, String pathID) throws Exception
	{
		File f = s0_getFile(pathID);
		if(f==null || !f.exists()) return;
    	Properties p = prop(f);
    	if(!p.isEmpty()) handleProp(p);
    }
	
	private void handleProp(Properties p)
    {
    	Iterator it = p.keySet().iterator();
    	while(it.hasNext())
    	{
    		String key = (String) it.next();
    		String value = p.getProperty(key);
    		if(!key.startsWith("#")) initPool(key,value);
    	}
    }
	
	
	private void initPool(String key, String value)
	{
		try
		{
			if(!value.equals("null"))
			{
				Entity entity = s1_provideUniqueEntity(value);
				putPool(key,entity);
			}
			else removePool(key);
			printM(this,"initPool(String,String)","init ["+key+"]=["+value+"]");
		}
		catch(Exception e)
		{err(this,"initPool(String,String)",e);}
	}
}
