package gus05.manager.gus.kassia.layer3.v03.handlestartlist;

import java.io.File;
import java.util.ArrayList;

import gus05.framework.core.Entity;
import gus05.manager.gus.kassia.layer3.tools.AbstractResourceLoader;

public class V03 extends AbstractResourceLoader {

	
	
	public static void handleStart() throws Exception
	{
		putPool(POOL_LIST_STARTEDENTITIES, new ArrayList()); 
		
		long t1 = System.currentTimeMillis();
		new V03().load("start", PROPKEY_SEQUENCE_START, RESOURCEPATH_START);
		long t2 = System.currentTimeMillis();
		
		printM(V03.class,"handleStart()","Start sequences time: "+ms(t2-t1));
	}
	
	
	protected void load_fromInside_(int index, String resourceID) throws Exception
	{
		String startText = insideText(resourceID);
        if(startText==null) return;
        
        printM(V03.class,"load_fromInside_(int,String)","Start sequence "+index+": "+resourceID);
        String[] lines = startText.split("[\n\r]+");
        startEntities(lines);
	}


	protected void load_fromPathID_(int index, String pathID)
	{
		try
		{
			printM(V03.class,"load_fromPathID_(int,String)","Start sequence "+index+": "+pathID);
	        File f = s0_getFile(pathID);
	        
	        if(f==null) throw new Exception("External start sequence ["+pathID+"] not found");
	        if(!f.isFile())throw new Exception("File ["+f+"] does not exist for start sequence ["+pathID+"]");

	        String text = text(f);
	        String[] lines = text.split("[\n\r]+");
	        startEntities(lines);
		}
		catch(Exception e)
		{err(V03.class,"load_fromPathID_(String)",e);}
	}
	
	
	
    
    
    private static void startEntities(String[] lines)
    {
        for(int i=0;i<lines.length;i++)
        if(!lines[i].equals("") && !lines[i].startsWith("#"))
            startEntity(lines[i]);
    }
    
    
    

    private static void startEntity(String line)
    {
    	printM(V03.class,"startEntity(String)","Start: "+line);
    	createStartEntity(line);
    }
    
    
    
    
    
    private static void createStartEntity(String name)
    {
    	try
        {
        	Entity entity = s1_provideUniqueEntity(name);
        	startedList().add(entity);
        }
        catch(Exception e)
        {
        	String message = "Entity start failed: ["+name+"]";
            err(V03.class,"createStartEntity(String)",new Exception(message,e));
        }
    }
}
